<%--
 * Component: cases
 *
 * Description:
 *   WorkList page (and QuickView of a study and Prefetch)
 *
 * Parameters:
 *
 *  @param cList_0         [userID/]listName
 *
 *  @param cPreFetch       true at Prefetch request (prefetch session)
 *  @param cQV             STYIUID of viewed study (at QuickView)
 *
--%><%@
	page import="imagemed.imtables.PrevNextTopCell.NeighboursDescriptor,java.util.*,java.io.*,java.sql.*,java.text.Format,imagemed.imsession.*,imagemed.util.*,imagemed.jsputil.*,imagemed.exception.*,
			imagemed.http.*,imagemed.tables.*,imagemed.imtables.*,imagemed.types.string.*,imagemed.types.*,imagemed.types.flag.IMTypeur,
			imagemed.http.tabs.*, imagemed.lists.*, imagemed.layout.*,imagemed.layout.datasource.*, imagemed.dotcom.*,
			imagemed.imtables.queryqualifier.QueryQualifier,imagemed.imtables.DBLDSWrapperSqlResult.IncrementalContext, imagemed.users.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%-- Global variables --%><%!

	String thisPage = "index.jsp";
	String thisPageFN = "/cases/index.jsp"; // Full Name
	String thisPageFNUE = Helper.URLEncodeUTF8(thisPageFN); // URLEncoded full name

	imagemed.types.date.IMTypeDA_TM dispDATM = new imagemed.types.date.IMTypeDA_TM();
	imagemed.types.IMType dispType = new imagemed.types.IMType();
	imagemed.types.string.IMTypeiS dispTypeiS = new imagemed.types.string.IMTypeiS();

%><%-- Input Parameters --%><%IMSession is = new IMSession(request, response, out);
	IMRequest parReq = new IMRequest(request);
	boolean isPrefetch = "true".equals(parReq.getVal("cPreFetch"));
	if (isPrefetch && !TabBean.hasLicense( TabBean.LICENSE_PREFETCH ) ) {
		out.println(LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_PREFETCH_LICENSE" ) );
		return;
	}
	boolean isUpdate = "true".equals(parReq.getVal("cUpdateData"));

	String parUser = parReq.getVal("cUser");
	String parSet = parReq.getVal("cSet"); // img size (64x64, etc.) for quick view
	Connection IMDB = IMEnv.getDB();

	if (isPrefetch) {
		String viewerVersion = request.getHeader("ViewerVersion");
		if (null == viewerVersion)
			viewerVersion = "";
		if (viewerVersion.compareTo("04.00.02.03") < 0) {
			is.bCheckHttpsAndRedirect = false;
		}
		response.setContentType("text/plain");
	}

	if (!is.regOK()) {
		out.println("<!--registration failed-->");
		return;
	}
	
	HoverTable m_hoverTable = new HoverTable( "colorHover", new HoverTable.Position(HoverTable.OffsetType.ELEMENT_BOTTOMRIGHT, -210, HoverTable.OffsetType.ELEMENT_TOPLEFT, -300), "#e0e0e0" );
	StringBuffer mes = new StringBuffer();
	mes.append( "<div style=\"font-size: 10pt; white-space: nowrap; width: 210; color: black;\">" );
	mes.append( "<SPAN class=\"X0 BgLight\">&nbsp;&nbsp;&nbsp;</SPAN><SPAN class=\"X0 BgLight_2\">&nbsp;&nbsp;&nbsp;</SPAN>&nbsp;" + LocalizedMessage.getSimpleMessage( "CASES_INDEX_PRIORITY_NORMAL" ) + "<BR>" ); 
	mes.append( "<SPAN class=\"X0 BgLowPriorityHiRow\">&nbsp;&nbsp;&nbsp;</SPAN><SPAN class=\"X0 BgLowPriorityHiRow_2\">&nbsp;&nbsp;&nbsp;</SPAN>&nbsp;" + LocalizedMessage.getSimpleMessage( "CASES_INDEX_PRIORITY_LOW_PRIORITY" ) + "<BR>" ); 
	mes.append( "<SPAN class=\"X0 BgPriorityHiRow\">&nbsp;&nbsp;&nbsp;</SPAN><SPAN class=\"X0 BgPriorityHiRow_2\">&nbsp;&nbsp;&nbsp;</SPAN>&nbsp;" + LocalizedMessage.getSimpleMessage( "CASES_INDEX_PRIORITY_HIGH_PRIORITY" ) + "<BR>" ); 
	mes.append( "<SPAN class=\"X0 BgShortCutRow\">&nbsp;&nbsp;&nbsp;</SPAN><SPAN class=\"X0 BgShortCutRow_2\">&nbsp;&nbsp;&nbsp;</SPAN>&nbsp;" + LocalizedMessage.getSimpleMessage( "CASES_INDEX_PRIORITY_SHORTCUT" ) + "<BR>" );
	mes.append( "<SPAN class=\"X0 BgShortCutLowPriorityHiRow\">&nbsp;&nbsp;&nbsp;</SPAN><SPAN class=\"X0 BgShortCutLowPriorityHiRow_2\">&nbsp;&nbsp;&nbsp;</SPAN><SPAN style=\"white-space: nowrap;\">&nbsp;" + LocalizedMessage.getSimpleMessage( "CASES_INDEX_PRIORITY_LOW_PRIORITY_SHORTCUT" ) + "</SPAN><BR>" );
	mes.append( "<SPAN class=\"X0 BgShortCutPriorityHiRow\">&nbsp;&nbsp;&nbsp;</SPAN><SPAN class=\"X0 BgShortCutPriorityHiRow_2\">&nbsp;&nbsp;&nbsp;</SPAN><SPAN style=\"white-space: nowrap;\">&nbsp;" + LocalizedMessage.getSimpleMessage( "CASES_INDEX_PRIORITY_HIGH_PRIORITY_SHORTCUT" ) + "</SPAN><BR>" );
	mes.append( "<SPAN class=\"X0 BgAbnormalHiRow\">&nbsp;&nbsp;&nbsp;</SPAN><SPAN class=\"X0 BgAbnormalHiRow_2\">&nbsp;&nbsp;&nbsp;</SPAN>&nbsp;" + LocalizedMessage.getSimpleMessage( "CASES_INDEX_PRIORITY_REPORT_ALERT" ) + "<BR>" );
	mes.append( "<SPAN class=\"X0 BgLowPriorityAbnormalHiRow\">&nbsp;&nbsp;&nbsp;</SPAN><SPAN class=\"X0 BgLowPriorityAbnormalHiRow_2\">&nbsp;&nbsp;&nbsp;</SPAN>&nbsp;" + LocalizedMessage.getSimpleMessage( "CASES_INDEX_PRIORITY_LOW_PRIORITY_REPORT" ) + "<BR>" );
	mes.append( "<SPAN class=\"X0 BgPriorityAbnormalHiRow\">&nbsp;&nbsp;&nbsp;</SPAN><SPAN class=\"X0 BgPriorityAbnormalHiRow_2\">&nbsp;&nbsp;&nbsp;</SPAN>&nbsp;" + LocalizedMessage.getSimpleMessage( "CASES_INDEX_PRIORITY_HIGH_PRIORITY_REPORT" ) + "<BR>" );
	mes.append( "<SPAN class=\"X0 BgCorrectionHiRow\">&nbsp;&nbsp;&nbsp;</SPAN><SPAN class=\"X0 BgCorrectionHiRow_2\">&nbsp;&nbsp;&nbsp;</SPAN>&nbsp;" + LocalizedMessage.getSimpleMessage( "CASES_INDEX_PRIORITY_EXPIRED" ) + "<BR>" );
	mes.append( "<SPAN class=\"X0 BgLowPriorityCorrectionHiRow\">&nbsp;&nbsp;&nbsp;</SPAN><SPAN class=\"X0 BgLowPriorityCorrectionHiRow_2\">&nbsp;&nbsp;&nbsp;</SPAN>&nbsp;" + LocalizedMessage.getSimpleMessage( "CASES_INDEX_PRIORITY_LOW_PRIORITY_EXPIRED" ) + "<BR>" );
	mes.append( "<SPAN class=\"X0 BgPriorityCorrectionHiRow\">&nbsp;&nbsp;&nbsp;</SPAN><SPAN class=\"X0 BgPriorityCorrectionHiRow_2\">&nbsp;&nbsp;&nbsp;</SPAN>&nbsp;" + LocalizedMessage.getSimpleMessage( "CASES_INDEX_PRIORITY_HIGH_PRIORITY_EXPIRED" ) + "<BR>" );
	mes.append( "<SPAN class=\"X0 BgSort1\">&nbsp;&nbsp;&nbsp;</SPAN><SPAN class=\"X0 BgSort1_2\">&nbsp;&nbsp;&nbsp;</SPAN>&nbsp;" + LocalizedMessage.getSimpleMessage( "CASES_INDEX_PRIORITY_SORTED_ONE" ) + "<BR>" );
	mes.append( "<SPAN class=\"X0 BgSort2\">&nbsp;&nbsp;&nbsp;</SPAN><SPAN class=\"X0 BgSort2_2\">&nbsp;&nbsp;&nbsp;</SPAN>&nbsp;" + LocalizedMessage.getSimpleMessage( "CASES_INDEX_PRIORITY_SORTED_TWO" ) + "<BR>" );
	mes.append( "<SPAN class=\"X0 BgSort3\">&nbsp;&nbsp;&nbsp;</SPAN><SPAN class=\"X0 BgSort3_2\">&nbsp;&nbsp;&nbsp;</SPAN>&nbsp;" + LocalizedMessage.getSimpleMessage( "CASES_INDEX_PRIORITY_SORTED_THREE" ) );
	mes.append( "</div>" );
	m_hoverTable.add( new HoverTable.Message( "COLORLEGEND", null, "Warning", mes.toString() ) );

	parReq = is.imRequest;
	if (parReq == null) {
		parReq = new IMRequest(request);
	}

	String parOpen = parReq.getVal("cOpen"); // open this study (STYIUID)
	String qvStudyIUID = WorklistToolbox.getQVStudy( is, null );

	boolean parSlowQuery = "true".equals( is.request.getParameter( "cDoSlowQuery" ) );

	boolean isSeeDeleted = "true".equals( is.imRequest.digUpVal("cSeeDeleted", "" ) );

	Defs casesDefs = new Defs(is, parUser == null ? null : new User( parUser ) );
	boolean shouldRedir = (!isPrefetch && !isUpdate && !Table.isExporting(is) && (is.imRequest.m_context == null || is.request.getParameterMap().containsKey("cDisposableContext")));
	String contextName = "";
	if (!isPrefetch && !isUpdate && !Table.isExporting(is)) {
		contextName = is.imRequest.passAsFileExcept( is.imRequest.m_context, "cQV," + WorklistToolbox.PREVNEXTCONTEXT + "," + WorklistToolbox.ISPREV );
	}
	// quick view shouldn't save it's private parameter into it's caller's context.

	if (shouldRedir) {
		String suffix = "";
		if (qvStudyIUID != null && qvStudyIUID.length() > 0) {
			suffix = "&cQV=" + qvStudyIUID;
		}
		response.sendRedirect("/cases/index.jsp?cContext=" + contextName + suffix);
		return;
	}
	
	// -- Some setup --

	boolean isAdmin = is.hasRight( IMTypeur.ADMIN_RIGHT );
	boolean hasForwardRight = is.hasRight( IMTypeur.FORWARD_EXPORT_RIGHT );
	// this is not used, because putting to a folder doesn't require Forward right
	
	boolean hasCopyRight = is.hasRight( IMTypeur.COPY_RIGHT );
	boolean hasEditRight = is.hasRight( IMTypeur.EDIT_RIGHT );
	boolean hasSchedulingRight = is.hasRight( IMTypeur.SCHEDULING_RIGHT );
	boolean hasOpenRight = is.hasRight( IMTypeur.OPEN_RIGHT );
	boolean hasReportRight = is.hasRight( IMTypeur.REPORT_RIGHT );
	boolean hasTranscribeRight = is.hasRight( IMTypeur.TRANSCRIBE_RIGHT );
	boolean hasDeleteRight = is.hasRight( IMTypeur.DELETE_RIGHT );
	boolean hasSupportRight = is.hasRight( IMTypeur.SUPPORT_RIGHT );
	boolean hasDumpRight = is.hasRight( IMTypeur.DUMP_RIGHT );
	boolean hasScanRight = is.hasRight( IMTypeur.SCAN_RIGHT );

	WorklistTableParams tparams = null;
	try {
		tparams = new WorklistTableParams(is, casesDefs.getFilterUser(), isAdmin, is.isRegisteredViewer());
	}
	catch (Exception e) {
		// Prefetch user was null
		if (!isPrefetch) { // forwarding is still possible
			throw e;
		}
		else {
			Helper.DEBUG("cases/index.jsp", Helper.throwable2String(e));
		}
	}
	tparams.setDefaults(thisPageFN, is);
	tparams.setDefaultPage(1);
	tparams.setDefaultPageSize(Defs.pageSize);
	tparams.setDefaultRefreshTime(Defs.refresh);
	tparams.setDefaultChangedFirst("false");

	qvStudyIUID = WorklistToolbox.getQVStudy( is, null );
	boolean isQuickView = qvStudyIUID != null;

	boolean isIntegrated = isQuickView && "true".equals( parReq.getVal( "cIntegrated" ) );
	
	String qvSourceStudy = null; // Will be used on the Quick View page to show images from original studies
	boolean qvIsLinkStudy = false; // Indicates whether the study is a link study
	String qvHub = null; // Owner HUB - for the Study move tool link on a quick view page
	int qvMainSt = -1; // Main status - for the Study move tool link on a quick view page
	int qvReportSt = -1; // Report status - for the send report to RIS link on a quick view page
	int qvSumObj = -1; //Number of objects in Study
	String qvOrderID = null;
	boolean isUIDqvOrderID = false;

	if (isQuickView && !isUpdate) {
		String patientName = null;
		String modality = null;
		String studyDate = null;
		ResultSet rs = IMEnv.getDB().createStatement().executeQuery(
			"select PNAME, MODALITY, STYDATETIME, OWNERHUB, REPORTST, MAINST, ORDERNUM, SRCSTUDY from " + IMEnvBase.getEnv("STUDYTBL") + " where STYIUID='" + qvStudyIUID + "'");
		if (rs.first()) {
			patientName = rs.getString( "PNAME" );
			modality = rs.getString( "MODALITY" );
			studyDate = new imagemed.types.date.TimeStamp( rs.getString( "STYDATETIME" ) ).getDA();

			qvHub = rs.getString( "OWNERHUB" );
			qvMainSt = rs.getInt( "MAINST" );
			qvReportSt = rs.getInt( "REPORTST" );
			qvSourceStudy = rs.getString( "SRCSTUDY" );
			qvIsLinkStudy = !qvStudyIUID.equals( qvSourceStudy );
			qvOrderID = rs.getString( "ORDERNUM" );
			if ( qvOrderID == null || "".equals( qvOrderID ) ) {
				qvOrderID = qvStudyIUID;
				isUIDqvOrderID = true;
			}
		}

		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "quickview" );
		logEntry.setField( OperLogEntry.FIELD.USER, is.regID );
		logEntry.setField( OperLogEntry.FIELD.STUDY, qvStudyIUID );
		logEntry.setField( OperLogEntry.FIELD.PNAME, patientName );
		logEntry.setField( OperLogEntry.FIELD.MODALITY, modality );
		logEntry.setField( OperLogEntry.FIELD.STUDYDATE, studyDate );
		logEntry.log( "cases_index", 0, Syslog.LOG_INFO );

//		Syslog slog = new Syslog("cases_index", 0, IMEnvBase.getEnv("LOG_OPER_FACILITY"));
//		slog.syslog(Syslog.LOG_INFO, "INFO STUDY quickview " + Syslog.logValue(is.regID) + " - " + qvStudyIUID + " " + patientName + " " + modality + " - - - - - - - "
//			+ Syslog.logValue(dispStyDate));
	}

	String onload = "";
	if (parOpen != null) {
		String url = "getpbs.jsp";
		if ( IMSession.isGetPbsServlet() ) {
			url = "../GetPbs/" + System.currentTimeMillis() + ".pbs";
		}
		onload = " onLoad='document.location.href=\"" + url + "?cGr=" + parOpen + "\"' ";
	}

	String globalNoPass = "r_no_refresh,r_setc";
	String passPars = tparams.getPassParams();
	String passExceptQVSet = "cContext=" + contextName;

	String qs = is.request.getQueryString();
	qs = (qs == null) ? "" : "?" + qs;
	String tU = is.httpx_host + is.request.getRequestURI() + qs;
	String encodedThisURL = Helper.URLEncodeUTF8( tU );

	
	TableDescriptor tdesc = new TableDescriptor(thisPageFN, true, true, true, true);
	tdesc.setHoverHelp( m_hoverTable, "COLORLEGEND" );

	tdesc.setIsUpdating(isUpdate);

	if (!isPrefetch && !isQuickView && !isUpdate) { // if it will show ordinary worklist
		tdesc.formParams = " action=\"" + GetpbsToolbox.getURLforOperInCases() + "\" method=\"POST\"";

		String uglyAddendum = ">\n<input type=hidden name=\"cInstr\" value=\"unset\">\n";
		uglyAddendum += "<input type=hidden name=\"cBack\" value=\"" + tU + "\"";

		String otherParams = tparams.passParamsExcept(globalNoPass);
		StringTokenizer st = new StringTokenizer(otherParams, "&");
		while (st.hasMoreTokens()) {
			String nextToken = st.nextToken();
			int p = nextToken.indexOf("=");
			String name = nextToken.substring(0, p);
			String value = nextToken.substring(p + 1);
			uglyAddendum += ">\n<input type=hidden name=" + name + " value='" + Helper.htmlEncode(Helper.URLDecodeUTF8(value)) + "'";
		}
		tdesc.formParams += uglyAddendum;
	}

	tdesc.setRefreshConfigFileName(IMEnvBase.getEnv("CONF") + "/wlrefresh.cfg");

	if( parSlowQuery ) {
		tdesc.setRefresh( false );
	}
	
	String backParams = "&cBack=" + encodedThisURL;
	String relevParams = "&cTableParams=" + Helper.URLEncodeUTF8(passPars) + tparams.getPassFields();

	Properties extraProperties = new Properties();
	extraProperties.setProperty("Rights", (is.regRights == null ? "" : is.regRights));
	extraProperties.setProperty("RelevParams", relevParams);
	extraProperties.setProperty("BackParams", backParams);
	extraProperties.setProperty("cIntegrated", ""+isIntegrated);

	WorklistProperties tprop = new WorklistProperties(extraProperties);
	FieldManager fm = EntryLayoutFactory.getDefaultFieldManager( is, LayoutPart.STUDYLAYOUT );//new IMSQLFieldManager("Dcfields", "Dctypes", WorklistToolbox.SQLTABLES);

	tdesc.setTableParams(tparams);
	tdesc.setTablePackage("imagemed.imtables");
	tdesc.setTableProperties(tprop);
	tdesc.setFieldManager(fm);
	tdesc.setSortDepth(3);

	String rights = "";
	int maxStat = 0;
	if (hasOpenRight) {
		rights += "o";
	}
	if (!isQuickView) {
		rights += "q";
	}
	if (hasEditRight) {
		rights += "e";
	}
	if (hasSchedulingRight) {
		rights += "s";
	}
	if (hasDeleteRight || hasSchedulingRight || tparams.isFolder()) {
		rights += "d";
		maxStat = (hasSchedulingRight && !hasDeleteRight) ? -10 : 100;
	}
	if (hasCopyRight) {
		rights += "c";
	}
	if (isAdmin) {
		rights += "a";
	}
	
	// if there's no valid forward target, act like there's no forward right
	Set<String> targets = IMAdminToolbox.getForwardTargets( is.regID );
	if ( !targets.isEmpty() ) {
		rights += "f";
	}

	if ("false".equals(IMEnv.getConfigProperty(IMEnv.GUI_CONF, "SuppressLocalOnly", "false")) && WorklistToolbox.hasArchive() && !tparams.isFolder()) {
		rights += "p";
	}
	if ( hasReportRight || hasTranscribeRight || hasEditRight || hasOpenRight ) {
		// access to lock status indicator light
		rights += "l";
	}
	
	ComboAction comboAction = null;
	SimpleHeader qvHeader = null;
	if (isUpdate) {
		Set<String> studySet = new HashSet<String>();
		Enumeration<?> parNames = request.getParameterNames();
		while (parNames.hasMoreElements()) {
			String parName = (String) parNames.nextElement();
			if ( parName.startsWith( "id_" ) ) {
				String id = Helper.URLDecodeUTF8( parName.substring( 3 ) );
				if ( id.indexOf( "/" ) == -1 ) {
					// non-composite ID, it must be a sudyUID
					studySet.add( id );
				}
			}
		}
		LockStatManager lsm = new LockStatManager(is, studySet);
		comboAction = new ComboAction(tdesc, "SYUI", rights, maxStat, true, lsm);
	}
	else {
		comboAction = new ComboAction(tdesc, "SYUI", rights, maxStat, true);
	}

	List<TopCell> topCell = new ArrayList<TopCell>();
	
	FiltersTopCell filtersTopCell = new FiltersTopCell(tdesc, null, isQuickView, new String[0], true);
	
	if (!isUpdate) {
		boolean isDedicated = is.isRegisteredViewer();
		topCell.add(new ListsTopCell( ListType.WORKLIST, tdesc, casesDefs.getUserId(), isAdmin, isQuickView));
		if (!isQuickView) {
			topCell.add(new FieldsTopCell(tdesc, null, true));
			topCell.add(new FiltersTopCell(tdesc, null, isQuickView, new String[0], true));
			topCell.add(new SortsTopCell(tdesc, null, isQuickView, true));
			topCell.add(new SeparatorTopCell(tprop, 4));
			topCell.add(new ExpansionModesTopCell(tdesc));
			topCell.add(new SeparatorTopCell(tprop, 4));
			topCell.add(new PriorityFirstTopCell(tdesc));
			if (isDedicated) {
				topCell.add(new LocalOnlyTopCell(tdesc));
			}
			if( isAdmin ) {
		    topCell.add( new SeparatorTopCell(tprop, 4) );
		  	topCell.add( new SeeDeletedTopCell(tdesc) );
			}
	
//			topCell.add(new ColorLegendTopCell(tdesc, m_hoverTable, "COLORLEGEND" ));
		}
	}
	Column col = null;
	if (isQuickView) {
		Action act[] = new Action[1];
		act[0] = comboAction;
		qvHeader = new SimpleHeader( "" );
		if (!isIntegrated) {
			topCell.add(new SeparatorTopCell(tprop, 0));
			col = new Column(qvHeader, new ActionCell("SYUI", act), "SYUI");
		}
	}
	else { // !quickView
		if (!isUpdate) {
			topCell.add(new PageTopCell(tprop, tparams));
		}
		Action act[] = new Action[2];
		act[0] = new RelevantCheckbox(tprop, "SYUI", "cGr", null, true, false, true);
		act[1] = comboAction;

		rights = "";
		if (hasOpenRight) {
			rights += "O";
		}
		if (hasDeleteRight || hasSchedulingRight) {
			rights += "D";
		}
		if ( !targets.isEmpty() ) {
			rights += "F";
		}
		if (hasEditRight) {
			rights += "E";
			if ( !tparams.isFolder()) { // merge studies
				rights += "M";
			}
		}
		if (hasReportRight) {
			rights += "R";
		}
		Action[] batchAct = new Action[]{new ComboAction(tdesc, ComboAction.TYPE_BATCH, rights)};
		col = new Column(new BatchHeader(batchAct), new ActionCell("SYUI", act), "SYUI");
	}

	if (col != null) {
		tdesc.addExtraColumn("_FIRST", col);
	}
	tdesc.setTopCells(topCell.toArray(new TopCell[0]));

	WorklistResult result = null;
	if (Table.isExporting(is)) {
		result = new WorklistResult(is, tdesc, true, !isSeeDeleted ); // listWholeTable
	}
	else {
		result = new WorklistResult(is, tdesc, tdesc.isUpdating(), !isSeeDeleted );
	}

	if (is.isRegisteredViewer()) {
		result.setRefreshingFields(new String[]{ "STAT", "LOAD", "NOBJ", "NIMG", "NSER", "SSIZ", "ATNM", "ATNO", "p001"});
	}
	else {
		result.setRefreshingFields(new String[]{ "STAT", "NOBJ", "NIMG", "NSER", "SSIZ", "ATNM", "ATNO", "p001"});
	}

	tdesc.setResult(result);

	if (isPrefetch) {
		WorklistToolbox.doPrefetch( is );
		return;
	} // isPrefetch

	NeighboursDescriptor neighbourDesc = (isQuickView && !isUpdate && !isIntegrated)?PrevNextTopCell.getNeightbours( is, is.imRequest.m_context, qvStudyIUID ):null;
 	if (isQuickView && !isUpdate) {
		Properties singleFilter = new Properties();
		singleFilter.setProperty( "SYUI", qvStudyIUID );
		tparams.setFiltersDirectly( singleFilter );
		tdesc.getTableParams().setPageDirectly( 1 );
		tdesc.getTableParams().setPageSize( 1 );
 		result.next();
 	}

	Table table = new Table(tdesc);

	if (isUpdate) {
		table.printTableAJAXData(is);
		return;
	}

	if (table.handleExport(is)) {
		return;
	}

	out.println("<!--" + Helper.request2String2(request) + ", " + is.regID + "-->");
	is.response.setHeader("pragma", "no-cache");
	is.response.setHeader("Cache-Control", "no-cache, must-revalidate");
	is.response.setHeader("Expiry-Date", "Friday, 31-Dec-70 23:59:59 GMT");
%><%-- ----- HTML code ----- --%><HTML>
<HEAD>
<TITLE><%=is.http_server%> - <%=IMEnvBase.getEnv("COMP_NAME")%> <%=LocalizedMessage.getSimpleMessage( "CASES_INDEX_HTMLPAGE_TITLE" )%></TITLE>
 <SCRIPT Language="JavaScript">
	var pageContext="<%=contextName%>";
 </script>
<%
	table.printScript(tparams, is);
	TabToolbox.writeIMpopup(out);
	Table.printUpdateScript(is);
	m_hoverTable.printJS( is );
	
	if ( isQuickView ) {
%>
	<STYLE type="text/css" id="qvCSS">
		A.qvoper {
			margin-left: 4px;
			margin-right: 4px;
		}
		
		span.epvwebOpenSpan {
			<%--=is.httpx_host == is.https_host?"display: none":""--%>;
		}
		
		table.DeviceDown {
			margin-left: auto;
			margin-right: auto;
			margin-top: 20px;
			text-align: left;
		}
		
	</STYLE>
<%
	}
	int jetty_port = 8081;
	try {
		jetty_port = Integer.parseInt( IMEnvBase.getEnv( "JETTY_PORT" ) );
	}
	catch ( Throwable e ) {
	}
%>
 <SCRIPT Language="JavaScript">
 var jetty_port = "<%=jetty_port%>";
	function FullWindow_( pRedirHost, pStudy_, pFname_, pI_, pWindow_, pX_, pY_ ) {
		vX = parseInt( pX_ ) + 30;        //2 pix + opt. scroll
		if ( vX < 200 )
			vX = 200;                       //for text width in bottom frame
		else if ( 800 < vX )
			vX = 800;
		vY = parseInt( pY_ ) + 54;        //fot text height in bottom frame
		if ( 600 < vY )
			vY = 600;
		psPart = "";
		if (pRedirHost != "") {
			psPart = "ParentSession=<%=is._sid%>&";
		}
		w = window.open( pRedirHost + '/cases/qvwin.jsp?'+psPart+'cStudy='+pStudy_+'&cFile=' +pFname_+ '&cI=' +pI_+ '&cX=' +pX_+ '&cY=' +pY_ , pWindow_,
				'menubar=no,location=no,resizable=yes,scrollbars=yes,status=no,width=' + vX + ',height=' + vY );
		w.focus();
	}

	function doSubmitChanged(frm,val) {
		frm.cChangedFirst.value = val;
		frm.submit();
	}

	function doSubmitLocal(frm,val) {
		frm.cLoc.value = val;
		frm.submit();
	}

	/*
	 Reload page after image object is scanned for an order
	 Will redirect to the worklist page
	*/
	function reloadPageAfterStudyScan() {
		 setTimeout( "self.document.location='<%=thisPageFN%>?cContext=<%=contextName%>';", 1000 );
	} 
	
<%if ( !isQuickView ) {%>

	var hasBatchCalled = false;

	function Batch_( op ) {
		if ( hasBatchCalled ) {
			return;
		}
		
		if (op != "Open") {
			// batch open does not leave the page so setting the flag would disable any further batch operations
			hasBatchCalled = true;
		}
		
		if (op == "Mrg") {
			self.document.Batch.action = "merge.jsp";
		}
		else {
			if (op == "bAp") {
				self.document.Batch.action = "batchReportSign.jsp";
			}
			else if (op == "Fwd") {
				self.document.Batch.action = "forward.jsp";
			}
			else if (op == "WvOpen") {
				self.document.Batch.action = "oper.jsp";
			}
			else if (op == "Del") {
				self.document.Batch.action = "delete.jsp";
			}
			else if (op == "bEd") {
				self.document.Batch.action = "batchEdit.jsp";
				self.document.Batch.cContext.name = "ccContext"; 
				// this is a hack, I don't want to pass the original context (except in backURL)
			}
			self.document.Batch.cInstr.value = op;
		}
		self.document.Batch.submit();
	}

<%}
	else {%>

	var isIntegrated = <%=isIntegrated%>;
	
	// Shows the object tools (preview/delete) in a hover over objects
	//
	// @param type    object type ('thumbnail' or 'icon') 
	// @param event   mouseover event
	// @param elem    the thumbnail or icon of the object
	// @param study   study instance UID of the object
	// @param file    short file name of the object
	// @param cols    pixel columns in object
	// @param rows    pixel
	function showToolDiv( type, event, elem, study, file, cols, rows, cnt, win ) {
		if (isIntegrated) {
			return;
		}
		toolDiv = getelementbyid( type + 'hovertool' );
		toolDiv.style.top = ( calcElementTop(elem) + elem.offsetHeight - 25 ) + 'px';
		toolDiv.style.left = ( calcElementLeft( elem ) + 1 ) + 'px';
		toolDiv.style.visibility = "visible";
	
		delForm = getelementbyid( 'delObjectForm' );
		previewForm = getelementbyid( 'previewObjectForm' );
	
		if ( delForm ) {
			delForm.cFile.value = file;
		}
	
		previewForm.cFile.value = file;
		previewForm.cStudy.value = study;
		previewForm.cX.value = cols;
		previewForm.cY.value = rows;
		previewForm.cI.value = cnt;
		previewForm.window.value = win;
	}
	
	// Hides the tools hover of objects 
	//
	// @param type    object type ('thumbnail' or 'icon') 
	function hideToolDiv( type ) {
		if (isIntegrated) {
			return;
		}
		toolDiv = getelementbyid( type + 'hovertool' );
		toolDiv.style.visibility = "hidden";
	}


	function cancelDelete() {
		var delDiv = getelementbyid( 'delObjectDiv' );
		var transparentDiv = getelementbyid( 'transparency' );
		transparentDiv.style.display = "none";
		delDiv.style.visibility = "hidden";

		if ( hasPageRefreshTimer ) {
			startTablePageRefreshTimer();
		}
	}
	
	// Deletes selected object by submitting the delete object form
	function deleteObject() {
		if ( hasPageRefreshTimer ) {
			cancelTablePageRefreshTimer();
		}
		var delForm = getelementbyid( 'delObjectForm' );
		var delDiv = getelementbyid( 'delObjectDiv' );
		var transparentDiv = getelementbyid( 'transparency' );
		transparentDiv.style.display = "block";
		delDiv.style.visibility = "visible";
		delDiv.style.zIndex = 9999;

		var wleft = (document.all)?document.body.scrollLeft:window.pageXOffset;
		var wtop = (document.all)?document.body.scrollTop:window.pageYOffset;

		var winWidth = document.body.clientWidth;
		var winHeight = document.body.clientHeight;

		if ( typeof( window.innerWidth ) == 'number' ) {
			winWidth = window.innerWidth;
			winHeight = window.innerHeight;
		}
		
		var centerX = wleft + (winWidth / 2);
		var centerY = wtop + (winHeight / 2);
		
		delDiv.style.left = (centerX - 250);
      delDiv.style.top = (centerY - 175); 
		delForm.submit();
	}
	
	// Previews selected object in a pop-up window
	function previewObject() {
		previewForm = getelementbyid( 'previewObjectForm' );
		var pI = previewForm.cI.value;
		var pX = previewForm.cX.value;
		var pY = previewForm.cY.value;
		var pFile = previewForm.cFile.value;
		var pStudy = previewForm.cStudy.value;
		var pRedirHost = previewForm.host.value;
		var pWin = previewForm.window.value;
	
		var vX = parseInt( pX ) + 30;        //2 pix + opt. scroll
		if ( vX < 200 )
			vX = 200;                       //for text width in bottom frame
		else if ( 800 < vX )
			vX = 800;
		var vY = parseInt( pY ) + 54;        //fot text height in bottom frame
		if ( 600 < vY )
			vY = 600;
		var psPart = "";
		if ( pRedirHost != "" ) {
			psPart = "ParentSession=<%=is._sid%>&";
		}
		w = window.open( pRedirHost + '/cases/qvwin.jsp?'+psPart+'cStudy='+pStudy+'&cFile='+pFile+ '&cI=' +pI+ '&cX=' +pX+ '&cY=' +pY , pWin,
				'menubar=no,location=no,resizable=yes,scrollbars=yes,status=no,width=' + vX + ',height=' + vY );
			w.focus();
	}

	function reLoadPage() {
		var delDiv = getelementbyid( 'delObjectDiv' );
		if ( delDiv ) {
			delDiv.display = 'none';
		}
		var delObjFrame = getelementbyid( 'delFrame' );
		if ( delObjFrame ) {
			delObjFrame.src = 'about:blank';
		}
		refreshTablePage();
	}

	
	var morelessName = "asc";
	
	var moreTitle = "<%=LocalizedMessage.getSimpleMessage( "SHOW_HIDDEN_ATTACHMENTS" )%>";
	var lessTitle = "<%=LocalizedMessage.getSimpleMessage( "HIDE_HIDDEN_ATTACHMENTS" )%>";

	/* Initialize more/less div to show/hide hidden attachments */
	function initMoreLess() {
		var img = getelementbyid( "imgmoreless" );
		morelessName = "asc";
		img.src = "/cases/art/" + morelessName + suffix + ".gif";
		img.title = moreTitle;
	}
	
	/* Show/hide hidden attachments */
	function toggleMoreLess( img ) {
		var attDiv = getelementbyid( "hiddenAttachments" );
		var img = getelementbyid( "imgmoreless" );
		if ( 'asc' == morelessName ) {
			attDiv.style.visibility = "visible";
			attDiv.style.display = "block";
			
			morelessName = "desc";
			img.title = lessTitle;
		}
		else {
			attDiv.style.visibility = "hidden";
			attDiv.style.display = "none";

			morelessName = "asc";
			img.title = moreTitle;
		}
		img.src = "/cases/art/" + morelessName + suffix + ".gif";
	}

<%}%>
</script>

</HEAD>
<BODY<%=onload%>>
<%
	if (!isIntegrated) {
		TabToolbox.makeTabs(is, is.tabbean, "cases/index.jsp", "White");
	}

	m_hoverTable.printHoverDiv( is );
	String colStudyRowShadow = tprop.getColor("StudyRowShadow");
%><%--  --------------------------------------------------------
        -                                                      -
        -   Create TABLE head (list quick select, etc.)        -                                              -
        -                                                      -
        -------------------------------------------------------- --%>
<%
	table.printTableTop(is);

	/******************
	 End of first table
	 ******************/

//checking slow queries
	String queryResult = null;
	if( !parSlowQuery && !isQuickView ) {
		QueryQualifier qq = new QueryQualifier();
		queryResult = qq.qualifyFilters( tparams, true, false );
		if( !QueryQualifier.GOOD.equals( queryResult ) ) {
			String help = qq.getHelp();
			WorklistToolbox.generateBadQueryForm( is, help, QueryQualifier.BAD.equals( queryResult ), filtersTopCell );
			return;
		}
	}

	boolean enableAutoUpdate = false;
	if( (hasOpenRight || hasReportRight) && (!isQuickView) ){
		IMProperties sysRec = new IMProperties();
		sysRec.recRead(IMEnvBase.getEnv("CONF") + "/system.rec");
		enableAutoUpdate = "false".equals(sysRec.getProperty("DISABLE_AUTOUPDATING_VIEWER"));	
	}
	if( enableAutoUpdate && !isIntegrated ){
		IMPropsConfigReader debugReader = new IMPropsConfigReader( IMEnvBase.getEnv( "CONF" ) + "/debug.cfg" );
		debugReader.checkAndLoad();
		String debug = ( (IMPropsConfiguration) debugReader.getConfiguration() ).getProperties().getProperty( "viewer", "false" );
	
		out.println("<div id=\"appletpanel\" style='height:1px;position:absolute;z-index:-1;width:0px;left:-1000px'>");
		out.println("<EMBED id=\"getversionApplet\"");
		out.println(" type=\"application/x-java-applet\"");
		out.println(" RCODEBASE=\"" +  is.httpx_host + "/applets\"");
		out.println(" CODE=\"ep.clients.GetViewerVersionApplet\"");
		out.println(" ARCHIVE=\"" + is.httpx_host + "/applets/epapplets.jar," + is.httpx_host + "/applets/jai_codec.jar\"");
		out.println("WIDTH = \"0%\"");
		out.println("HEIGHT = \"0\"");
	
		//read version from file
		String readFilePath = IMEnvBase.getEnv( "VIEWER_HOME" ) + "/plugins.std/pbupgrade.plv";
		PbupgradeConfigReader pbUpgradeConfReader = PbupgradeConfigReader.getConfigReaderInstance( readFilePath, null );
		pbUpgradeConfReader.checkAndLoad();
		PbupgradeConfiguration pbupgradeConf = (PbupgradeConfiguration) pbUpgradeConfReader.getConfiguration();
		String strServerVersion = pbupgradeConf.getVersionValue( PbupgradeConfigReader.SERVER_VERSION );
		String strMinViewerVersion = pbupgradeConf.getVersionValue( PbupgradeConfigReader.MIN_VERSION );
		if(strServerVersion == null){
			strServerVersion = "";
		}
		if(strMinViewerVersion == null){
			strMinViewerVersion = "";
		}

		out.println( "ServerVersion = \"" + strServerVersion + "\"" );
		out.println( "ViewerDownloadUrl = \"" + is.httpx_host + "/cases/downloadMain.jsp" + "\"" );
		out.println( "PbupgradeMinVersion = \"" + strMinViewerVersion + "\"");
	
		if(debug.equals("true") ){
			out.println( "debug = " + debug );
		}
		else{
			out.println( "debug = \"false\"");
		}
		out.println( "server = \"" + is.httpx_host + "\"" );
		out.println(" sessionid = \"" + is._sid + "\">");
	
		out.println("</div>");
	}

	if (isQuickView) {
		String prevQV = null;
		String nextQV = null;
%><BR>
<%=JSHelper.getJsInclude( JSHelper.LAYOUTSCRIPTS_JS )%>
<script language=javascript>
		function showWebViewerButton() {
			if (<%=is.httpx_host == is.https_host%>) return;
			try {	
				var s = my_getelementbyid("qvCSS");
				for (var i = 0; i<s.sheet.cssRules.length; i++) {
					//alert(dumpObj(s.sheet.cssRules[i]));
					if (new String(s.sheet.cssRules[i].selectorText).toLowerCase() == "span.epvwebopenspan") {
						//alert("gotcha");
						s.sheet.deleteRule(i);
					}
				}
			}
			catch (e){
				alert(e);
			}
		};

//var vvc = new webViewerChecker();
//vvc.onSuccess = 
//showWebViewerButton();
//vvc.startCheck();
	
</script>

<%
	//String neighbour[] = 
		table.printOneRowTable(is);
	
		try {
			if ( !("true".equals(is.imRequest.getVal("cHidePrevNext")) || isIntegrated)) {
				prevQV = neighbourDesc.m_prevStudy;
				nextQV = neighbourDesc.m_nextStudy;
			}
		}
		catch (Throwable th) {}
%><%--  --------------------------------------------------------
        -                                                      -
        -   Quick View images                                  -                                              -
        -                                                      -
        -------------------------------------------------------- --%><%
	/****** prepare cSet, thnc, thnr *****/

	
		IMProperties setpr = new IMProperties();
		UserPreferences prefs = new UserPreferences( is.regID );
		prefs.load();

		if ( parSet != null ) {
			prefs.setPreference( "qv_thumbnail_size", parSet );
			prefs.save();
		}
		else {
			parSet = prefs.getPreference( "qv_thumbnail_size" );
		}

		int thex = parSet.indexOf("x");
		if (thex == -1) {
			parSet = UserPreferences.getDefaultValue( "qv_thumbnail_size" );
			thex = 3;
		}

		int thnc = Integer.parseInt(parSet.substring(0, thex));
		int thnr = Integer.parseInt(parSet.substring(thex + 1));

		// It should be working
		String pname = result.getValue("PANM");
		IMTypePANM displayPANM = new IMTypePANM();
		pname = isIntegrated?displayPANM.displayFieldText( pname, "PANM", extraProperties ):displayPANM.displayField(pname, null, result, extraProperties, is);

		String redirHost = RedirectToolbox.getRedirectForStudy(is, qvStudyIUID);
		String sessionParam = "";
		if (redirHost == null) {
			redirHost = "";
		}
		else {
			sessionParam = "&ParentSession=" + Helper.URLEncodeUTF8(is._sid) + "&RefererHost=" + RedirectToolbox.getThisHostEnc(is);
		}

		String redirBackURL = Helper.URLEncodeUTF8( is.httpx_host + thisPageFN + "?cQV=" + Helper.URLEncodeUTF8( qvStudyIUID ) + "&cContext=" + contextName );
%>
 <BR>
 <TABLE width="100%" cellpadding=2 cellspacing=0 border=1 class=BgShadow>
   <TR>
    <TD width="60%" nowrap>
     <FONT size=6><B>
     &nbsp;&nbsp;<%=pname%>

     </td><TD width="20%" align="center">
         <script language="JavaScript">getImage("iconsize", 73, 21, "");</script>
<%
		if (!parSet.equals("64x64")) {
%>
        <A href="<%=thisPage%>?cQV=<%=qvStudyIUID%>&cSet=64x64&<%=passExceptQVSet%>">
         <script language="JavaScript">getImage("iconSmall", 19, 21, "");</script>
         </a>
<%
		}
		else {
%>
         <script language="JavaScript">getImage("iconSmall", 19, 21, "");</script>
<%
		}
		if (!parSet.equals("128x128")) {
%>
        <A href="<%=thisPage%>?cQV=<%=qvStudyIUID%>&cSet=128x128&<%=passExceptQVSet%>">
         <script language="JavaScript">getImage("iconMedium", 22, 21, "");</script>
         </a>
<%
		}
		else {
%>
         <script language="JavaScript">getImage("iconMedium", 22, 21, "");</script>
<%
		}
		if (!parSet.equals("256x256")) {
%>
        <A href="<%=thisPage%>?cQV=<%=qvStudyIUID%>&cSet=256x256&<%=passExceptQVSet%>">
         <script language="JavaScript">getImage("iconLarge", 26, 21, "");</script>
         </a>
<%
		}
		else {
%>
         <script language="JavaScript">getImage("iconLarge", 26, 21, "");</script>
<%
		}
%>

     </td>
<% if (!isIntegrated) { %>     
     <TD align="right" nowrap>
<%
		if ( neighbourDesc.m_isMissing ) {
			is.out.println("<font color=red> " + LocalizedMessage.getSimpleMessage( "CASES_INDEX_OUT_OF_CONTEXT" ) + "</font>");
		}
		if (prevQV != null) {
    	//<A href="<%=thisPage% >?cQV=<%=prevQV% >&cContext=<%=contextName% >">
    	out.println("<A href=\""+thisPage+"?cContext="+contextName+"&"+WorklistToolbox.PREVNEXTCONTEXT+"="+Helper.URLEncodeUTF8( neighbourDesc.m_incrementalContext.toString())+"&"+WorklistToolbox.ISPREV+"=true\">");
%>
         	<%=JSHelper.getJsLocalizedButton( "BUTTON_PREVIOUS_STUDY", "BUTTON_NULL", false)%>
         </a>
       &nbsp;
<%
		}
		if (nextQV != null) {
    	//     <A href="<%=thisPage% >?cQV=<%=nextQV% >&cContext=<%=contextName% >">
    	out.println("<A href=\""+thisPage+"?cContext="+contextName+"&"+WorklistToolbox.PREVNEXTCONTEXT+"="+Helper.URLEncodeUTF8( neighbourDesc.m_incrementalContext.toString())+"&"+WorklistToolbox.ISPREV+"=false\">");
%>
         	<!-- <script language="JavaScript">getButton("NextStudy", "");</script> -->
         	<%=JSHelper.getJsLocalizedButton( "BUTTON_NEXT_STUDY", "BUTTON_NULL", false )%>
         </a>
<%
		}
%>
       &nbsp;&nbsp;
       	<A href="<%=thisPage%>?cContext=<%=contextName%>">
       		<!-- <script language="JavaScript">getButton("BacktoList", "");</script> -->
       		<%=JSHelper.getJsLocalizedButton( "BUTTON_BACK_TO_LIST", "BUTTON_NULL", false )%>
       	</a>
       	
     </td>
<%} %>
    </tr>
<%if (!isIntegrated) { %>
    <tr>
     <td colspan=5 align="center" nowrap>
       <A href="<%=redirHost%>/cases/reset.jsp?cGr=<%=qvStudyIUID%>&cBack=<%=redirBackURL%><%=sessionParam%>&cOp=Cache"><%=LocalizedMessage.getSimpleMessage( "CASES_INDEX_CLEAR_CACHE" )%></A>
 |     <A href="<%=redirHost%>/cases/reset.jsp?cGr=<%=qvStudyIUID%>&cBack=<%=redirBackURL%><%=sessionParam%>&cOp=Process"><%=LocalizedMessage.getSimpleMessage( "CASES_INDEX_REPROCESS" )%></A>
 |     <A href="<%=redirHost%>/cases/reset.jsp?cGr=<%=qvStudyIUID%>&cBack=<%=redirBackURL%><%=sessionParam%>&cOp=Index"><%=LocalizedMessage.getSimpleMessage( "CASES_INDEX_REINDEX" )%></A>
 |     <A href="<%=redirHost%>/cases/reset.jsp?cGr=<%=qvStudyIUID%>&cBack=<%=redirBackURL%><%=sessionParam%>&cOp=Full"><%=LocalizedMessage.getSimpleMessage( "CASES_INDEX_FULL" )%></A>
	</td></tr><tr><td colspan=5 align="center" nowrap>
<%
	//		if (!qvIsLinkStudy && !StudyToolbox.hasShortcut( qvStudyIUID ) && !tparams.isFolder() && (isAdmin || hasEditRight)) {
		if ( hasEditRight ) {
			try {
				EditToolbox.isStudyEditable( is, qvStudyIUID, "", "" );
				String splitBackURL = Helper.URLEncodeUTF8( is.httpx_host + thisPageFN + "?cContext=" + contextName );
	%>
	      <A class="qvoper" href="<%=redirHost%>/cases/split.jsp?cStudy=<%=qvStudyIUID%>&cBack=<%=splitBackURL%><%=sessionParam%>">
	      	<%=JSHelper.getJsLocalizedButton( "BUTTON_SPLIT", "BUTTON_NULL", false )%>
	      </A>&nbsp;&nbsp;&nbsp;&nbsp;
	<%
			}
			catch (IMGeneralException e) {
			}
		}
		if (hasEditRight) {
			if (is.isIPhone() || is.isIPad() || "true".equals(request.getParameter( "isIphone" ))) { // debug
	%>        
	    <a class="qvoper" href="eradv<%=is.httpx_host.substring(4).toLowerCase()%>/cases/describeStudy.jsp?sessionid=<%=is._sid%>&cStudy=<%=qvStudyIUID%>&cBack=<%=encodedThisURL%>">
	 	  	<%=JSHelper.getJsButton( is, "opennew.png", 0, 0, LocalizedMessage.getSimpleMessage( "BUTTON_OPEN_TITLE" ) )%>
	    </a>
	<%
			}
			else {
	%>
	    <a class="qvoper" href="<%=GetpbsToolbox.getURLforGetpbs()%>?cGr=<%=qvStudyIUID%>">
	 	  	<%=JSHelper.getJsButton( is, "opennew.png", 0, 0, LocalizedMessage.getSimpleMessage( "BUTTON_OPEN_TITLE" ) )%>
	    </a>
	<%
			}
		}
%>
	    <span class="epvwebOpenSpan"><a class="qvoper" id="epvwebOpen" href="/EPVWeb/EPVWeb.jsp?cStudy=<%=qvStudyIUID%><%=backParams%>#studyview">
  	  	<%=JSHelper.getJsButton( is, "openbrowserviewer.png", 0, 0, LocalizedMessage.getSimpleMessage( "BUTTON_OPEN_TITLE" ) )%>
    	</a></span>
  <%
// removed by Balage ( by GaborL )   if (hasEditRight) {
  %>
	    <a class="qvoper" href="/cases/patientFolder.jsp?cStudy=<%=qvStudyIUID%>">
	    	<%=JSHelper.getJsButton( is, "patientfolder.png", 0, 0, LocalizedMessage.getSimpleMessage( "PATIENTFOLDER_OPEN" ) )%>
	    </a>
	<%
//	}
	%>
  &nbsp;&nbsp;&nbsp;&nbsp;
  <%
  	//SCAN/UPLOAD stuff - only for non-link
		if (  !qvIsLinkStudy &&	hasScanRight ) {
	   	String type = AttachmentManager.getScanTargetType();
	   	String altJpg = LocalizedMessage.getSimpleMessage( "SCAN_JPG_ALT_TEXT" );
	   	String altPdf = LocalizedMessage.getSimpleMessage( "SCAN_PDF_ALT_TEXT" );
	   	String altUpload = LocalizedMessage.getSimpleMessage( "UPLOAD_ALT_TEXT" );
	   	String doctypeDefault = AttachmentManager.getDefaultDoctypeName( "DTQD" );
	   	String doctypeDefaultUpload = AttachmentManager.getDefaultDoctypeName( "DTQU" );
	   	
	   	if ( qvMainSt >= 0 ) {
	   		if( !is.isLinux() && TabBean.hasLicense( TabBean.LICENSE_SCAN ) ) {
	   			// scanning for studies
	   			if ( !AttachmentManager.SCANTO_PDF.equals( type ) ) {
	        				//scan into jpg button
	  %><A class="qvoper" HREF="#" onclick="IMpopupSame( '/cases/preDicomScan.jsp?cStudyIUID=<%=qvStudyIUID%>&cDoctypeDefault=<%=Helper.URLEncodeUTF8( doctypeDefault )%>', 'PopUpScan', 'scrollbars=auto, resizable=yes,'); return false;"><%=JSHelper.getJsButton( is, "scanAsJPG", 24, 24, altJpg )%></a><%
	  			}
	        if ( !AttachmentManager.SCANTO_JPG.equals( type ) ) {
	        				//scan into pdf button
	  %><A class="qvoper" HREF="#" onclick="IMpopupSame( '/cases/preDicomScan.jsp?cPDF=true&cStudyIUID=<%=qvStudyIUID%>&cDoctypeDefault=<%=Helper.URLEncodeUTF8( doctypeDefault )%>', 'PopUpScan', 'scrollbars=auto, resizable=yes,'); return false;"><%=JSHelper.getJsButton( is, "scanAsPDF", 24, 24, altPdf )%></a><%
	  			}
	     	}
	  %> <A class="qvoper" HREF="#" onclick="IMpopupCenter( '/cases/preDicomScan.jsp?cStudyIUID=<%=qvStudyIUID%>&cDoctypeDefault=<%=Helper.URLEncodeUTF8( doctypeDefaultUpload )%>&cUploadOnly=true', 'PopUpScan', '<%=AttachmentManager.UPLOADWINDOW_WIDTH%>', '<%=AttachmentManager.UPLOADWINDOW_HEIGHT%>', 'scrollbars=auto, resizable=yes,'); return false;"><%=JSHelper.getJsButton( is, "uploadnew.png", 24, 24, altUpload )%></a><%
	 	// upload button
	   	}
	  	else {
	    // scanning for orders
	    // only for the topmost device in the Single Enterprise				
		 		DotcomDevice selfDevice = DotcomConfig.selfDevice();
		 		if( selfDevice != null && selfDevice ==  DotcomConfig.getConfig().getTopMostDeviceInSingleEnterprise() ) { 
		 			String scanRedir = null;
		 			String redirParams = "";
		 			boolean needLink = true;
		 			try {
		 				scanRedir = RedirectToolbox.getOrderAttachmentRedirect( is, qvSourceStudy );
		 				if ( scanRedir == null ) {
		 					scanRedir = "";
		 				}
		 				else {
		 					redirParams = "&" + RedirectToolbox.getRedirectParams( is );
		 				}
		 			}
		 			catch ( IMException imEx ) {
		 				Helper.DEBUG( "scanLink", "No scan link is needed for order " + qvOrderID + ": " + Helper.throwable2String( imEx ) );
		 				needLink = false;
		 			}
		 			if ( needLink ) {
		 				String scanURL = scanRedir + "/cases/prePACSOrderScan.jsp?id=" + Helper.URLEncodeUTF8( qvOrderID ) + "&cStudyIUID=" + qvStudyIUID + "&isUID=" + isUIDqvOrderID + redirParams;
		 				if( !is.isLinux() && TabBean.hasLicense( TabBean.LICENSE_SCAN ) ) {
		 					if ( !AttachmentManager.SCANTO_PDF.equals( type ) ) {
		 						//scan into jpg button
		%><A class="qvoper" HREF="#" onclick="IMpopupSame( '<%=scanURL + "&cDoctypeDefault=" + Helper.URLEncodeUTF8( doctypeDefault )%>', 'PopUpScan', 'scrollbars=auto, resizable=yes,'); return false;"><%=JSHelper.getJsButton( is, "scanAsJPG", 24, 24, altJpg )%></a><%
							}
		  				if ( !AttachmentManager.SCANTO_JPG.equals( type ) ) {
		  						//scan into pdf button
		%><A  class="qvoper" HREF="#" onclick="IMpopupSame( '<%=scanURL+ "&cDoctypeDefault=" + Helper.URLEncodeUTF8( doctypeDefault )%>&cPDF=true', 'PopUpScan', 'scrollbars=auto, resizable=yes,'); return false;"><%=JSHelper.getJsButton( is, "scanAsPDF", 24, 24, altPdf )%></a><%
							}
		  			}
		  			//upload button
		%> <A  class="qvoper" HREF="#" onclick="IMpopupCenter( '<%=scanURL + "&cDoctypeDefault=" + Helper.URLEncodeUTF8( doctypeDefaultUpload )%>&cUploadOnly=true', 'PopUpScan', '<%=AttachmentManager.UPLOADWINDOW_WIDTH%>', '<%=AttachmentManager.UPLOADWINDOW_HEIGHT%>', 'scrollbars=auto, resizable=yes,'); return false;"><%=JSHelper.getJsButton( is, "uploadnew.png", 24, 24, altUpload )%></a><%
					}
		  	}
		  }
		} //scan
 %>
  &nbsp;&nbsp;&nbsp;&nbsp;
 <%
	  boolean moveButtonPresent = false;
          
	  if ( !qvIsLinkStudy && hasSupportRight || isAdmin ) {
	   	// Link to move study tool for regular studies on a CWL server
	   	DotcomDevice selfDevice = DotcomConfig.selfDevice();
	   	if (qvMainSt >= 0 && qvHub != null && qvHub.length() != 0 && selfDevice.isDbOnly() && !selfDevice.hasMultipleClusters()) {
	   		moveButtonPresent = true;
  %>
	    <a class="qvoper" href="/dotcom/moveStudy.jsp?cStudy=<%=qvStudyIUID%>">
	    	<%=JSHelper.getJsLocalizedButton( "BUTTON_MOVE", "BUTTON_NULL", false )%>
	    </a>
	<%
			}
		}
		
		if ( hasSupportRight || isAdmin ) {
		// Send Report to RIS + Details buttons
		
			String[] hl7Servers = DotcomConfig.getConfig().getHl7Servers();
			if ( hl7Servers != null ) {
				moveButtonPresent = true;					
				boolean hasLocalHL7 = false;
				for ( String hl7Dev : hl7Servers ) {
					if ( DotcomConfig.selfId().equals( hl7Dev ) ) {
						hasLocalHL7 = true;
						break;
					}
				}
	
			boolean isDisabled = true;
			String altSendReport = LocalizedMessage.getSimpleMessage( "SEND_REPORT_ALT_TEXT" );
			if ( hasLocalHL7 && qvReportSt > 0 ) {
				ResultSet rs = IMEnv.getDB().prepareStatement( "select ID from " + IMEnvBase.getEnv( "DEVSERVTBL" ) +
				"," + IMEnvBase.getEnv( "TARGETTBL" ) + " where Service='RepU' and DEVICE=ID" ).executeQuery();
				if ( rs.next() ) {
%>
					<A class="qvoper" HREF="/cases/sendReport.jsp?cStudy=<%=qvStudyIUID%>">
					<%=JSHelper.getJsButton( is, "SendReport.png", 24, 24, altSendReport )%>
					</a>
<%
					isDisabled = false;
				}
				rs.close();
			}
			if ( isDisabled ) {
%>
					<%=JSHelper.getJsButton( is, "SendReport.d.png", 24, 24, altSendReport )%>
<%
			}
			
			String altSendOrder = LocalizedMessage.getSimpleMessage( "SEND_ORDER_ALT_TEXT" );
			if ( hasLocalHL7 ) {
%>
					<A class="qvoper" HREF="/cases/sendOrder.jsp?cStudy=<%=qvStudyIUID%>">
					<%=JSHelper.getJsButton( is, "SendOrder.png", 24, 24, altSendOrder )%>
					</a>
<%
			}
			else {
				out.println( JSHelper.getJsButton( is, "SendOrder.d.png", 24, 24, altSendOrder ) );
			}
		}
		if( moveButtonPresent ) {
%>
			  &nbsp;&nbsp;&nbsp;&nbsp;
<%
		}
%>
			<A class="qvoper" HREF="#" onclick="window.open( '/cases/studyInfo.jsp?cStudy=<%=qvStudyIUID%>', 'StudyInfo', 'resizable=yes,scrollbars=yes,width=800,height=600'); return false;">
				<%=JSHelper.getJsLocalizedButton( "BUTTON_DETAILS", "BUTTON_DETAILS_TITLE", false )%>
			</a>
			
			<A class="qvoper" HREF="/imadmin/jobs.jsp?cFields=1JID%0A1JNA%0A1QUE%0A1SNO%0A1TNO%0A1PRI%0A1RPR%0A1DAT%0A1PST%0APANM%0APAID%0AACCN%0ASYDT%0ADSCR&qf_1QUE=<%=Helper.URLEncodeUTF8( "\"*Retry*\";\"*Running*\";\"*Scheduled*\"")%>&qf_1PST=<%=qvStudyIUID%>">
				<%=JSHelper.getJsLocalizedButton( "BUTTON_TASKS", "ALT_TEXT_SEE_TASKS", false )%>
			</a>
			
<%
	} // is QuickView
%>
     </td>
    </tr>
<%} %>
  </table>
<%
	// Link studies / Source study
	Properties linkFilterProps = new Properties();
	if ( qvIsLinkStudy ) {
		qvHeader.setContent("Source Study");
		linkFilterProps.setProperty( "SYUI", qvSourceStudy );
	}
	else {
		qvHeader.setContent("Shortcuts");
		linkFilterProps.setProperty( "SSUI", qvStudyIUID );
		linkFilterProps.setProperty( "SYUI", "!\"" + qvStudyIUID + "\"" );
	}

	tparams.setFiltersDirectly( linkFilterProps );
	WorklistResult qvResult = new WorklistResult( is, tdesc, true, isSeeDeleted );

	if ( qvResult.countAll() > 0 ) {
		out.println("<BR>");
		comboAction.addRights("q");
		tdesc.setResult( qvResult );
		tdesc.setUpdatable( false );
		extraProperties.setProperty( "idPrefix", "T1_" );
		Table qvTable = new Table( tdesc );
			
		qvTable.printTableWithoutPageNavigation( is );
	}

	out.flush();

	try {
		QuickViewImages qvImages = QuickViewImages.rmiCollectQuickViewImages( null, qvStudyIUID, qvSourceStudy, new Boolean( qvIsLinkStudy ) );
		QuickViewIconPrinter qvIcon = new QuickViewIconPrinter( out, redirHost, hasDumpRight, hasDeleteRight );
		
		Vector<QuickViewImages.QuickViewSeries> qvSeries = qvImages.getSeries();
		if ( !qvSeries.isEmpty() ) {
			// Print series header table only if there is any image series in the study
			out.println("<BR>\n");
			out.println("<TABLE border=1 class=BgShadow cellpadding=0 cellspacing=0 width=\"100%\"><TR class=HeaderRow>");
		if (!isIntegrated) {
			out.println("<TD class=BgShadow width=\"7%\">&nbsp;</TD>");
		}
			out.println(Helper.headerCell3D(fm.getHeaderName("SRNM"), "center", "10%", 1));
			out.println(Helper.headerCell3D(fm.getHeaderName("MODA"), "center", "7%", 1));
			out.println(Helper.headerCell3D(fm.getHeaderName("SRDT"), "center", "20%", 1));
			out.println(Helper.headerCell3D(fm.getHeaderName("SRDS"), "center", null, 1));
			out.println(Helper.headerCell3D(fm.getHeaderName("NOBJ"), "center", "7%", 1));
			out.println(Helper.headerCell3D(fm.getHeaderName("NIMG"), "center", "7%", 1));
			out.println("</TR></TABLE><BR>");
		}
	
		if(!qvIsLinkStudy){
			int sumObjects = 0;
			QuickViewImages qvImagesTmp = QuickViewImages.rmiCollectForAPI( null, qvStudyIUID, qvStudyIUID );
			Vector<QuickViewImages.QuickViewSeries> qvSeriesTmp = qvImagesTmp.getSeries();
			for ( QuickViewImages.QuickViewSeries series : qvSeriesTmp ) {
				sumObjects += series.getObjectCount();
			}
			qvSumObj = sumObjects;
		}
	
		for ( QuickViewImages.QuickViewSeries series : qvSeries ) {
			out.println( "<TABLE border=1 class=BgShadow cellpadding=0 cellspacing=0 width=\"100%\"><TR>" );
		if (!isIntegrated) {
			out.println( "<TD class=BgMedDark width=\"7%\">" );
			if ( !qvIsLinkStudy && hasEditRight ) {
				String editUrl = redirHost + "/cases/seriesEdit.jsp?cStudy=" + Helper.URLEncodeUTF8( qvStudyIUID ) +
				"&cSeries=" + Helper.URLEncodeUTF8( series.getSeriesUid() ) + "&cBack=" + redirBackURL + sessionParam;
				out.println( JSHelper.getJsButtonSLink( is, editUrl, "/cases/art/edit.gif", 18, 20, LocalizedMessage.getSimpleMessage( "ALT_TEXT_EDIT_SERIES" ) ) );
			}
			if ( !qvIsLinkStudy ) {
				// this page will redirect if necessary
				String openUrl = "/EPVWeb/EPVWeb.jsp?cStudy=" + Helper.URLEncodeUTF8( qvStudyIUID ) +
				"&cSeries=" + Helper.URLEncodeUTF8( series.getSeriesUid() ) + "#studyview";
				out.println( "<span class=\"epvwebOpenSpan\">" + JSHelper.getJsButtonSLink( is, openUrl, "/cases/art/openbrowserviewer.png", 18, 20, LocalizedMessage.getSimpleMessage( "ALT_TEXT_OPEN_SERIES" ) ) + "</span>" );
			}
			if ( !qvIsLinkStudy && hasDeleteRight ) {
				String deleteUrl = redirHost + "/cases/seriesDelete.jsp?cStudy=" + Helper.URLEncodeUTF8( qvStudyIUID ) +
				"&cSeries=" + Helper.URLEncodeUTF8( series.getSeriesUid() ) + "&cSumObj=" + qvSumObj + "&cBack=" + redirBackURL + sessionParam;
				out.println( JSHelper.getJsButtonSLink( is, deleteUrl, "/cases/art/delete.gif", 17, 20, LocalizedMessage.getSimpleMessage( "ALT_TEXT_DELETE_SERIES" ) ) );
			}
			if ( qvIsLinkStudy || ( !hasEditRight && !hasDeleteRight ) ) {
				// Neither edit nor delete allowed to the user
				out.println( "&nbsp;" );
			}
			out.println("</TD>");
		}	
			out.println("<TD width=\"10%\">" + dispTypeiS.display( series.getSeriesNumber() ) + "&nbsp;</TD>");
			out.println("<TD width=\"7%\">" + dispType.display( series.getModality() ) + "&nbsp;</TD>");
			out.println("<TD width=\"20%\">" + dispDATM.display( series.getDateTime() ) + "&nbsp;</TD>");
			out.println("<TD>" + dispType.display( series.getDescription() ) + "&nbsp;</TD>");
			out.println("<TD width=\"7%\">" + series.getObjectCount() + "</TD>");
			out.println("<TD width=\"7%\">" + series.getFrameCount() + "</TD>");
			out.println("</TR></TABLE><BR>");
		
			Vector<QuickViewImages.QuickViewObject> seriesObjects = series.getObjects();
			for ( QuickViewImages.QuickViewObject obj : seriesObjects ) {
				String fname = obj.getFileName();
				
				if ( obj instanceof QuickViewImages.QuickViewNonImageObject ) {
					QuickViewImages.QuickViewNonImageObject niObj = ( QuickViewImages.QuickViewNonImageObject ) obj;
					qvIcon.print( qvImages.getSeriesStudy(), fname, niObj.getSOPClassUID(), niObj.getInstanceNumber(), true );
					continue;
				}
	
				// image objects
				QuickViewImages.QuickViewImageObject imgObj = ( QuickViewImages.QuickViewImageObject ) obj;
				
				int frames = imgObj.getFrameCount();
				int cols = imgObj.getCols();
				int rows = imgObj.getRows();
				String wname = fname.replace( '.', '_' );
				
				int thnc1 = thnc;
				int thnr1 = thnr;
				float vr = (float) cols / rows;
				if ( vr < 1 )
					thnc1 *= vr;
				if ( vr > 1 )
					thnr1 /= vr;
				
				for ( int i = 1; i <= frames; i++ ) {
					String imgname = fname + "_" + Integer.toString( i );
				
					out.print( "<A href=\"JavaScript:FullWindow_( '" + redirHost + "', '" + qvImages.getSeriesStudy() + "', '" + fname + "', '" + i + "', '" + wname + "', '" + cols + "', '" + rows + "' );\"" );
					out.print( " onMouseOver=\"window.status='" + qvStudyIUID + "/" + imgname +"';" );
					if ( !isIntegrated && hasDeleteRight ) {
						out.print( " showToolDiv( 'thumbnail', event, this, '" + qvImages.getSeriesStudy() + "', '" + fname +"', '" + cols + "', '" + rows + "', '" + i + "', '" + wname +"' );" );
					}
					out.print( " return true;\"" );
					if ( !isIntegrated && hasDeleteRight ) {
						out.print( " onMouseOut=\"hideToolDiv( 'thumbnail' );\"" );
					}
		
					out.print( "><IMG src=\"" + redirHost + "/cases/frame.jsp?f=" + qvImages.getSeriesStudy() + "/" + imgname + "." + parSet + "w.jpg\"" );
					out.println( " width=" + thnc1 + " height=" + thnr1 + " alt=\"" + series.getSeriesUid() + "/" + fname + " (" + cols + "x" + rows + ")\" border=0></A>" );
				}
			} // for obj
	
			out.println("<BR><BR>");
	
		} // for series
	
	
		Vector<QuickViewImages.QuickViewNonImageObject> qvDocs = qvImages.getDocuments();
		if ( qvDocs != null && !qvDocs.isEmpty() ) {
			// Print header
			out.println("<BR>");
			out.println("<TABLE border=1 class=BgShadow cellpadding=0 cellspacing=0 width=\"100%\"><TR>");
			out.println("<TD width=\"100%\" align=center>" + LocalizedMessage.getSimpleMessage( "CASES_INDEX_NON_IMAGE" ) + "</TD>");
			out.println("</TR></TABLE><BR>");
		
			for ( QuickViewImages.QuickViewNonImageObject doc : qvDocs ) {
				qvIcon.print( qvImages.getDocumentStudy(), doc.getFileName(), doc.getSOPClassUID(), doc.getInstanceNumber(), false );
			}
		
			if ( ! qvIcon.hasTrailingBr() ) {
				out.println( "<BR>" );
			}
		}
	
	
		// Attachments
		boolean hasHeaderPrinted = false;
		
		Vector<QuickViewImages.QuickViewObject> qvAttachments = qvImages.getAttachments();
		
		StringWriter writerHidden = new StringWriter( 1024 );
		
		for ( QuickViewImages.QuickViewObject attachment : qvAttachments ) {
			String docType = attachment.getDocumentType();
			AttachmentManager.ACCESS access = AttachmentManager.getAccess( docType, is.regID, AttachmentManager.LOCATION.QUICKVIEW );
			if ( access == AttachmentManager.ACCESS.NO ) {
				continue;
			}
		
			Writer attWriter = ( access == AttachmentManager.ACCESS.HIDDEN ) ? writerHidden : out;
		
			if (!hasHeaderPrinted) {
				hasHeaderPrinted = true;
				out.println("<BR>");
				out.println("<TABLE border=1 class=BgShadow cellpadding=0 cellspacing=0 width=\"100%\"><TR>");
				out.println("<TD width=\"100%\" align=center>" +
	(isIntegrated?"":"<A href=\"/cases/attachments.jsp?cStudy=" + Helper.URLEncodeUTF8( qvSourceStudy ) + "\">") + 
	LocalizedMessage.getSimpleMessage( "GENERIC_ATTACHMENTS" ) + 
	(isIntegrated?"":"</A>")+
	"</TD>");
				out.println("</TR></TABLE><BR>");
			}
		
		
			String fname = attachment.getFileName();
	
			if ( attachment instanceof QuickViewImages.QuickViewNonImageObject ) {
				QuickViewImages.QuickViewNonImageObject niObj = ( QuickViewImages.QuickViewNonImageObject ) attachment;
				qvIcon.print( attWriter, qvImages.getAttachmentStudy(), fname, niObj.getSOPClassUID(), niObj.getInstanceNumber(), true );
				continue;
			}
	
			// image attachments
			QuickViewImages.QuickViewImageObject imgObj = ( QuickViewImages.QuickViewImageObject ) attachment;
		
			int frames = imgObj.getFrameCount();
			int cols = imgObj.getCols();
			int rows = imgObj.getRows();
			String wname = fname.replace( '.', '_' );
		
			int thnc1 = thnc;
			int thnr1 = thnr;
			float vr = (float) cols / rows;
			if (vr < 1)
				thnc1 *= vr;
			if (vr > 1)
				thnr1 /= vr;
	
	
			for ( int i = 1; i <= frames; i++ ) {
				String imgname = fname + "_" + Integer.toString( i );
				
				attWriter.write( "<A href=\"JavaScript:FullWindow_( '" + redirHost + "', '" + qvImages.getAttachmentStudy() + "', '" + fname + "', '" + i + "', '" + wname + "', '" + cols + "', '" + rows + "' );\"" );
				attWriter.write( " onMouseOver=\"window.status='" + qvStudyIUID + "/" + imgname +"';" );
				if ( !isIntegrated && hasDeleteRight ) {
					attWriter.write( " showToolDiv( 'thumbnail', event, this, '" + qvImages.getAttachmentStudy() + "', '" + fname +"', '" + cols + "', '" + rows + "', '" + i + "', '" + wname +"' );" );
				}
				attWriter.write( " return true;\"" );
				if ( !isIntegrated && hasDeleteRight ) {
					attWriter.write( " onMouseOut=\"hideToolDiv( 'thumbnail' );\"" );
				}
				
				attWriter.write( "><IMG src=\"" + redirHost + "/cases/frame.jsp?f=" + qvImages.getAttachmentStudy() + "/" + imgname + "." + parSet + "w.jpg\"" );
				attWriter.write( " width=" + thnc1 + " height=" + thnr1 + " alt=\"" + fname + " (" + cols + "x" + rows + ")\" border=0></A>" );
				attWriter.write( "\n" );
			}
		} // for attachment;
	
		if ( writerHidden.getBuffer().length() > 0 ) {
			is.out.print( "<DIV id=\"tdmoreless\" class=\"moreless BgShadow\" style=\"height: 18px; width: 80px; margin-bottom: 5px; border: 1px solid; text-align: center; cursor: pointer;\" onClick=\"toggleMoreLess();\">" );
			is.out.print( "<IMG style=\"vertical-align: middle; padding: 3px;\" id=\"imgmoreless\">" );
			is.out.println( "</DIV>" );
			is.out.println( "<SCRIPT language=\"JavaScript\">initMoreLess();</SCRIPT>" );
			out.println( "<DIV id=\"hiddenAttachments\" style=\"visibility: hidden; display: none\">" );
			out.println( writerHidden.toString() );
			out.println( "</DIV>" );
		}
	
		if ( qvMainSt < 0 ) {
			Vector<AttachmentManager.SchedulerAttachment> orderAttachments = AttachmentManager.listAttachments( qvOrderID );
			if ( orderAttachments != null && !orderAttachments.isEmpty() ) {
				out.println("<BR>");
				out.println( "<TABLE border=1 class=BgShadow cellpadding=0 cellspacing=0 width=\"100%\"><TR>" );
				out.println( "<TD width=\"100%\" align=center><A href=\"/cases/attachments.jsp?cStudy=" + Helper.URLEncodeUTF8( qvSourceStudy ) + "\">" + LocalizedMessage.getSimpleMessage( "GENERIC_ATTACHMENTS" ) + "</A></TD>" );
				out.println( "</TR></TABLE><BR>" );
			}
		}
		
		if ( qvIsLinkStudy && hasDumpRight ) {
			Vector<QuickViewImages.QuickViewNonImageObject> qvLinkObjs = qvImages.getLinkObjects();
			if ( qvLinkObjs != null && !qvLinkObjs.isEmpty() ) {
				out.println("<BR>");
				out.println("<TABLE border=1 class=BgShadow cellpadding=0 cellspacing=0 width=\"100%\"><TR>");
				out.println("<TD width=\"100%\" align=center>" + LocalizedMessage.getSimpleMessage( "CASES_INDEX_SHORTCUT_OBJECTS" ) + "</TD>");
				out.println("</TR></TABLE><BR>");
					
				for  ( QuickViewImages.QuickViewNonImageObject obj : qvLinkObjs ) {
					qvIcon.print( qvImages.getLinkStudy(), obj.getFileName(), obj.getSOPClassUID(), obj.getInstanceNumber(), false );
				}
			}
		}
	}
	catch ( DeviceDownException ddEx ) {
		MessageBox mb = new MessageBox( "HUB is down", "60%", null, "DeviceDown" );
		String errMsg = LocalizedMessage.getCompoundMessage( "CASES_INDEX_HUB_INACCESSIBLE", new Format[] { null }, new Object[] { ddEx.getDevice() }, true );
		mb.setMessage( "<div class=\"FontError\">" + errMsg + "</div>" );
		mb.print( is.out );
	}
	
	if ( hasDeleteRight ) {
%>
<div id="thumbnailhovertool" class="popup" onmouseover="this.style.visibility = 'visible';" onmouseout="this.style.visibility = 'hidden';">
	<a href="JavaScript:previewObject()"><script language="JavaScript">getImage("qview", 18, 20, " alt='<%= LocalizedMessage.getSimpleMessage( "ALT_TEXT_PREVIEW_OBJECT" ) %>' title='<%= LocalizedMessage.getSimpleMessage( "ALT_TEXT_PREVIEW_OBJECT" ) %>'");</script></a>
	<% if ( !qvIsLinkStudy ) { %>
	<a href="JavaScript:deleteObject()"><script language="JavaScript">getImage("delete", 17, 20, " alt='<%= LocalizedMessage.getSimpleMessage( "ALT_TEXT_DELETE_OBJECT" ) %>' title='<%= LocalizedMessage.getSimpleMessage( "ALT_TEXT_DELETE_OBJECT" ) %>'");</script></a>
	<% } %>
</div>

<div id="iconhovertool" class="popup" onmouseover="this.style.visibility = 'visible';" onmouseout="this.style.visibility = 'hidden';">
<%
		if ( hasDumpRight ) {
%>
	<a href="JavaScript:previewObject()"><script language="JavaScript">getImage("qview", 18, 20, " alt='<%= LocalizedMessage.getSimpleMessage( "ALT_TEXT_PREVIEW_OBJECT" ) %>' title='<%= LocalizedMessage.getSimpleMessage( "ALT_TEXT_PREVIEW_OBJECT" ) %>'");</script></a>
<%
		}
		if ( !qvIsLinkStudy ) {
%>
	<a href="JavaScript:deleteObject()"><script language="JavaScript">getImage("delete", 17, 20, " alt='<%= LocalizedMessage.getSimpleMessage( "ALT_TEXT_DELETE_OBJECT" ) %>' title='<%= LocalizedMessage.getSimpleMessage( "ALT_TEXT_DELETE_OBJECT" ) %>'");</script></a>
<%
		}
	}
%>
</div>

<div id="transparency" style="display:none; position:absolute; left:0; top:0; width:3000px; height:5000px; background:#2e2e2e; filter:alpha(opacity=80); opacity:0.8; z-index:20;">&nbsp;</div>
<div id="delObjectDiv" style="visibility: hidden; position: absolute; left: 25px; top: 25px; border: 1px; border-style: outset; border-color: gray; width: 500px; height: 350px; background-color: #e0e0e0;">
	<iframe id="delFrame" name="delFrame" src="about:blank" width="100%" height="100%" frameborder="0" scrolling="no"></iframe>
</div>

<form method="get" name="previewObjectForm" id="previewObjectForm">
	<input id=previewStudy type="hidden" name="cStudy" value="<%= Helper.htmlEncode( qvSourceStudy ) %>">
	<input id=previewCount type="hidden" name="cI" value="">
	<input id=previewFile type="hidden" name="cFile" value="">
	<input id=previewCols type="hidden" name="cX" value="">
	<input id=previewRows type="hidden" name="cY" value="">
	<input id=previewWin type="hidden" name="window" value="">
	<input id=previewHost type="hidden" name="host" value="<%= Helper.htmlEncode( redirHost ) %>">
</form>


<form method="post" name="delObjectForm" id="delObjectForm" action="delObject.jsp" target="delFrame">
	<input type="hidden" name="cOp" value="Del">
	<input type="hidden" name="cStudy" value="<%= Helper.htmlEncode( qvSourceStudy ) %>">
	<input id=delFile type="hidden" name="cFile" value="">
	<input type="hidden" name="cSumObj" value="<%= qvSumObj %>">
</form>
</body></html>
<%
	return;
	} // QuickView - valahol 1 tab elmaszott
	table.print(is);

	out.println( ListSaveForm.getListSaveForm( ListType.WORKLIST, is, tdesc ) );
%>
<%-- "<pre>"+result.getDebug()+"</pre>" --%>
</BODY></HTML>
