//=========================================================================

function my_getelementbyid( id ) {
	if ( document.getElementById )
		return document.getElementById( id );
	else if ( document.all )
		return document.all[ id ];
	else if ( document.layers )
		return document.layers[ id ];
	else
		alert( "Browser not compatible" ); // TODO
}

function URLDecode( s ) {
	// this is supposed to be the inverse operation of java's URLEncode
	return unescape( s ).replace( /\+/g, " " );
}
// =========================================================================

function xmlhttpnew() {
	var xmlhttp_ = false;
	/* @cc_on @ */
	/*
	 * @if (@_jscript_version >= 5) // JScript gives us Conditional compilation,
	 * we can cope with old IE versions. // and security blocked creation of the
	 * objects. try { xmlhttp_ = new ActiveXObject("Msxml2.XMLHTTP"); } catch (e) {
	 * try { xmlhttp_ = new ActiveXObject("Microsoft.XMLHTTP"); } catch (E) {
	 * xmlhttp_ = false; } } @end @
	 */
	if ( !xmlhttp_ && typeof XMLHttpRequest != 'undefined' ) {
		try {
			xmlhttp_ = new XMLHttpRequest();
		}
		catch ( e ) {
			xmlhttp_ = false;
		}
	}
	if ( !xmlhttp_ && window.createRequest ) {
		try {
			xmlhttp_ = window.createRequest();
		}
		catch ( e ) {
			xmlhttp_ = false;
		}
	}
	if ( !xmlhttp_ ) {
		try {
			xmlhttp_ = new ActiveXObject( "Msxml2.XMLHTTP" );
		}
		catch ( e ) {
			try {
				xmlhttp_ = new ActiveXObject( "Microsoft.XMLHTTP" );
			}
			catch ( E ) {}
		}
	}
	if ( !xmlhttp_ ) {
		alert( "Browser does not support javascript HTTP Request !!" );
	}
	return xmlhttp_;
}

var xmlhttp = xmlhttpnew();

function getTime() {
	return new Date().getTime();
}

var lastUpdateData;
var currentUpdateData;

/*
 * this function applies a single line of the received update page
 */
function applyLine( line ) {
	var obj = eval( line );
	var id = obj[0];
	var type = obj[1];
	var value = obj[2];
	var element = my_getelementbyid( id );
	try {
		if ( 'T' == type ) {
			element.innerHTML = value;
			return true;
		}
		if ( 'S' == type ) {
			element.innerHTML = "";
			eval( value );
			return true;
		}
	}
	catch ( akarmi ) {
		// alert("element "+id+" invalid? ("+akarmi+": "+akarmi.description+",
		// "+akarmi.message+")");
	}
	// alert("a line could not be processed :"+line);
	// alert("the decoded value was :"+value);
	return false;
}

/*
 * this function processes the lines in allData
 */
function process( allData ) {
	var currentUpdateData = allData.split( "\n" );
	var forceUpdate = false;
	if ( !lastUpdateData ) {
		forceUpdate = true;
		lastUpdateData = allData.split( "\n" );
	}
	for ( var i = 0; i < currentUpdateData.length; i++ ) {
		if ( !forceUpdate && currentUpdateData[ i ] == lastUpdateData[ i ] ) {
			continue;
		}
		try {
			if ( currentUpdateData[ i ] ) {
				// skip last blank line
				applyLine( currentUpdateData[ i ] );
			}
			lastUpdateData[ i ] = currentUpdateData[ i ];
		}
		catch (e) {}
	}
	if ( navigator.appVersion.indexOf( "MSIE" ) != -1 ) {
		xmlhttp.abort();
	}
	procTime = getTime() - startTime;
	schTime = Math.max( 1000, 2000 + reqTime * 4 - procTime );
	setTimeout( xmlhttpcallrequest, schTime );
}

var startTime;
var reqTime;

/*
 * this function will be called if the update request returns a result
 */
function xmlhttpstatechanged() {
	if ( xmlhttp.readyState == 4 || xmlhttp.readyState == "complete" ) {
		startTime = getTime();
		reqTime = startTime - requestDate.getTime();
		allData = new String( xmlhttp.responseText );
		if ( allData.charAt( 0 ) == '<' ) {
			// server side failure/exception
			setTimeout( xmlhttpcallrequest, 10000 + reqTime );
			return;
		}
		process( allData );
	}
}
var requestDate;
/*
 * This method sends the update request
 */
function xmlhttprequest( xmlhttp_, url ) {
	try {
		if ( updateDataQuery ) {
			xmlhttp_.onreadystatechange = xmlhttpstatechanged;
			xmlhttp_.open( "POST", url, true );
			xmlhttp_.setRequestHeader( 'Content-Type', 'application/x-www-form-urlencoded;charset=iso-8859-2' );
			reqPars = "cContext=" + pageContext + "&cUpdateData=true&r_no_refresh=true" + updateDataQuery;
			xmlhttp_.setRequestHeader( "Content-Length", reqPars.length );
			xmlhttp_.send( reqPars ); // requestparams
			requestDate = new Date();
		}
		else { // maybe the page is not fully loaded
			setTimeout( xmlhttpcallrequest, 1000 );
		}
	}
	catch ( anything ) {
		setTimeout( xmlhttpcallrequest, 1000 );
	}
}

function xmlhttpcallrequest() {
	var answer = true;// confirm("�pd�teljek?");//true
	if ( answer ) {
		xmlhttprequest( xmlhttp, location.pathname );
	}
}

// =========================================================================

/*
 * this method runs the javascripts in a given node
 */
function executescripts( node ) {
	var x = node.getElementsByTagName( "SCRIPT" );
	alert( "node is " + node + ", Length: " + x.length );
	// + "\nFirst Item: "
	// + x[0].childNodes[0].nodeValue);

	for ( var i = 0; i < x.length; i++ ) {
		alert( "running script: " + x[ i ].text );
		eval( x[ i ].text );
		alert( "script finished." );
	}
	var y = node.children;
	alert( "node is " + node + ", Length: " + y.length );
	for ( var i = 0; i < x.length; i++ ) {
		alert( "running script: " + x[ i ].text );
		// eval(x[i].text);
		alert( "script finished." );
	}

}

// =========================================================================
// =========================================================================

// initialising update process
// wait a bit..otherwise ID tags won't exist
// (the page is not fully loaded yet!)
setTimeout( xmlhttpcallrequest, 2000 );
