<%@page import="imagemed.dotcom.proliferate.ProliferateUserListRename"%>
<%@
	page import="java.io.*, java.text.*, java.util.*,
		imagemed.actions.*, imagemed.exception.*, imagemed.http.IMRequest, imagemed.imtables.*,
		imagemed.imtables.queryqualifier.QueryQualifier, imagemed.imsession.*, imagemed.jsputil.*,
		imagemed.lists.*, imagemed.summaries.*, imagemed.tables.*, imagemed.types.flag.IMTypeur,
		imagemed.users.*, imagemed.util.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page pageEncoding="utf-8"
	 
%><%

	IMSession is = new IMSession( request, response, out );
	IMRequest reqPar = new IMRequest( is.request );
	String parOper = is.getButtonParam( "cOper" );

	Helper.DEBUG( "lists.jsp", "Oper: " + parOper );

	if ( null == parOper ) {
		if ( reqPar.exist( "cEnter" ) ) {
			parOper = "Save";
		}
		else {
			parOper = "";
		}
	}
	boolean isSaving = parOper != null && parOper.startsWith( "Save" );
	boolean isConfig = parOper != null && ( parOper.startsWith( "Configure" ) || parOper.startsWith( "SummaryConfigure" ) );
	//  is.bRegNotNeeded     = (parOper!=null);

	if ( !is.regOK( !isSaving && !isConfig ) ) { // don't merge context if saving or action modifying
		return;
	}
	if ( !is.bRegNotNeeded && is.regID == null ) {
		return;
	}
	if ( !is.hasRight( IMTypeur.LIST_SAVING_RIGHT ) ) {
		return;
	}
	String thisPage = "/cases/lists.jsp";

	boolean isAdmin = ( -1 != is.regRights.indexOf( 'A' ) );
	boolean isSupport = ( -1 != is.regRights.indexOf( '@' ) );
	boolean isUserManager = is.hasRight( IMTypeur.USER_MANAGE_RIGHT );

	reqPar = is.imRequest;
	ListType listType = ListType.fromIndexString( reqPar.getVal( "cListType" ), ListType.WORKLIST );
	try {
		String reqRights = listType.getRights();
		for ( int i = 0; i < reqRights.length(); i++ ) {
			if ( is.regRights.indexOf( reqRights.charAt( i ) ) < 0 ) {
				throw new IMException( LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTS_LISTS_RIGHT" ) + " " + LocalizedMessage.getSimpleMessage( listType.getGuiPluralLabel() ) + "." );
			}
		}
	}
	catch ( NumberFormatException | NullPointerException e ) {
	}

	boolean parSlowQuery = "true".equals( is.request.getParameter( "cDoSlowQuery" ) );

	String batchOperations = "CD";
	String[] defaultFields;
	if ( listType != ListType.WORKLIST ) { // non-worklist filters
		List<String> df = new ArrayList<String>();
		df.add( "LUSR" );
		df.add( "LLST" );
		if ( listType == ListType.BILLING ) {
			df.add( "SUSE" );
		}

		defaultFields = df.toArray( new String[ 0 ] );
		is.imRequest.setProperty( "cFields", defaultFields );
		is.imRequest.setProperty( "cSorts", new String[]{ "a_LUSR", "a_LLST" } );
		batchOperations = "D";
	}
	else {
		defaultFields = TableParams.getDefaultFields( thisPage, is );
	}

	reqPar.delProperty( "cEnter" );
	reqPar.delProperty( "cOper" );
	String context = reqPar.m_context;
	if ( context == null || context.length() == 0 ) {
		reqPar.expandList( "/cases/lists.jsp" );
		context = reqPar.backupContext();
	}
	else if ( !isSaving && !isConfig ) {
		reqPar.passAsFile( context );
	}

	/*
	  Saving worklist queries. The cFields, cSorts, and qf_* parameters are
	  saved in the named config file 

	  Input Parameters
	*/
	User listUser = is.getUser();
	String parUser = reqPar.getVal( "cListUser" ); //General
	if ( parUser != null && !parUser.isEmpty() ) {
		listUser = new User( parUser );
// 		if ( listUser.isSystem() ) {
//			UserFile filtersDir = ListFile.getFiltersDir( listUser, parListType );
//			if ( !filtersDir.exists() ) {
//				filtersDir.mkdirs();
//			}
//		}
	}

	String parListName = reqPar.getVal( "cListName" );
	if ( parListName != null && !parListName.equals( "" ) && !( parOper != null && ( parOper.startsWith( "Save" ) || parOper.equals( "RenameOver" ) ) ) ) {
		parListName = Helper.decodeByRty( reqPar.getVal( "cListName" ) );
		if ( !is.imRequest.exist( "cListType" ) ) {
			throw new RuntimeException( LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTS_UNDEFINED_TYPE" ) );
		}
	}
	if ( "SaveOverWriteActions".equals( parOper ) ) {
		parListName = Helper.decodeByRty( reqPar.getVal( "cListName" ) );
	}

	String parSaveType = reqPar.getVal( "savetype" ); //only at list saving
	//  String parStat     = reqPar.getVal("cStat");

	String parNewName = reqPar.getVal( "cNewName" ); //only at list renaming


	UserFile filterDirectory = ListFile.getFiltersDir( listUser, listType );
	if ( !filterDirectory.exists() ) {
		filterDirectory.mkdirs();
	}
	if ( null == parListName ) {
		parListName = "";
	}
	String htmlListName = Helper.htmlEncode( parListName );

%><%-- --- Functions --- --%><%!

	String checkListName( ListType listType, User parListUser, String parListName,
			boolean isAdmin, IMRequest reqPar, boolean isSupport ) {

		ListFile listFile = new ListFile( parListUser, listType, parListName );

		if ( !listFile.isDeletable() ) {
			return LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTS_NON_DELETABLE_EXISTS" );
		}
		if ( parListName.startsWith( "." ) && !isAdmin ) {
			return LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTS_ADMIN_RIGHT" );
		}
		if ( listType == ListType.WORKLIST && parListName.equals( ".archive" ) && parListUser.equals( "@system" ) && !isSupport ) {
			return LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTS_SUPPORT_RIGHT" );
		}
		if ( "".equals( parListName.trim() ) ) {
			return LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTS_EMPTY" ) + "\n" + parListName + reqPar.getVal( "cListName" );
		}
		IMRequest requestWithContext = new IMRequest( IMSession.getSession() );
		String[] compLists = requestWithContext.getVals( "cCompoundLists" );
		if ( compLists != null && compLists.length > 0 ) {
			String member = compLists[ 0 ];
			member = Helper.replace( member, "%2F", "/" );
			int p = member.indexOf( "/" );
			boolean hidden = member.charAt( p + 1 ) == '.';
			boolean newHidden = parListName.startsWith( "." );
			if ( hidden != newHidden ) {
				return LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTS_COMPOUND_HIDDEN_LISTS" );
			}
			for ( String compList : compLists ) {
				member = Helper.replace( compList, "%2F", "/" );
				p = member.indexOf( "/" );
				member = member.substring( p + 1 );
				if ( parListName.equals( member ) ) {
					return LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTS_COMPOUND_SELF_REFERRING" );
				}
			}
		}
		if ( parListName.indexOf( '\'' ) == -1 && parListName.indexOf( '\t' ) == -1 &&
			parListName.indexOf( '\r' ) == -1 && parListName.indexOf( '\n' ) == -1 &&
			parListName.indexOf( '/' ) == -1 && parListName.indexOf( ';' ) == -1 &&
			parListName.indexOf( '\"' ) == -1 && parListName.indexOf( '\\' ) == -1 &&
			parListName.indexOf( '?' ) == -1 ) {
			return ""; //correct
		}
		return "<CENTER>" + LocalizedMessage.getCompoundMessage( "EXCEPTION_LISTS_ILLEGAL_CHAR", new Format[]{ null }, new Object[]{ Helper.htmlEncode( parListName, true ) }, true ) + "</CENTER>";
	}

	//------end of functions------
%><%// --- Init Table without Result ---

	String thisPageMenuTab = thisPage.substring( 1 );
	TableDescriptor tdesc = new TableDescriptor( thisPage, true, true, true, false );
	TableProperties tprop = new TableProperties();
	UserList userList = new UserList();
	userList.setListType( listType );
	userList.setListUserRights( is.regRights );

	// choose the default fields corresponding to the displaying table

	TableParams tparams = new TableParams( is.imRequest );
	tparams.setDefaultFields( defaultFields );
	tparams.setDefaultPage( 1 );
	tparams.setDefaultPageSize( 20 );
	String queryString = is.request.getQueryString();
	if ( !parOper.startsWith( "Save" ) && ( queryString == null || "".equals( queryString ) ) ) {
		Properties defFilters = TableParams.getDefaultFilters( thisPage, is );
		tparams.setDefaultFilters( defFilters );
	}
	String[] defaultSort = TableParams.getDefaultSorts( thisPage );
	tparams.setDefaultSort( defaultSort );

	//	String returningParams = tparams.getPassFields()+tparams.getPassRefresh()+
	//		tparams.getPassPageSize()+tparams.getPassPage()+tparams.getPassFilters()+
	//		tparams.getPassSort()+(parStat==null?"&cStat=true":"&cStat="+parStat);
	String returningURL = thisPage + "?cContext=" + context;

	// decide what field manager to use

	if ( listType == ListType.WORKLIST ) {
		UserListFieldManager fm = new UserListFieldManager( is, userList );
		tdesc.setFieldManager( fm );
		tparams.setFields( fm.getFields() );
	}
	else { //if (parListType == 1) 
		UserFilterListFieldManager fm = new UserFilterListFieldManager( listType );
		tdesc.setFieldManager( fm );
	}
	//	else {
	//		throw new RuntimeException("unhandled list type "+parListType);
	//	}

	tdesc.setTableParams( tparams );
	tdesc.setTableProperties( tprop );
	tdesc.setSortDepth( 3 );

	Action act[] = new Action[ 2 ];
	act[ 0 ] = new CheckboxAction( tprop, "LUSR;LLST", "cGr", null );
	Properties extraProperties = new Properties();
	extraProperties.setProperty( "listType", Integer.toString( listType.getIndex() ) );
	if ( isAdmin ) {
		act[ 1 ] = new ComboAction( tdesc, ComboAction.TYPE_LIST, "drG", extraProperties );//G means, that the user can edit group lists
	}
	else {
		act[ 1 ] = new ComboAction( tdesc, ComboAction.TYPE_LIST, "dr", extraProperties );
	}

	Action[] batchAct = new Action[]{ new ComboAction( tdesc, ComboAction.TYPE_LIST_BATCH, batchOperations ) }; // batchOps="CD" or "D"

	BatchHeader bh = new BatchHeader( batchAct );

	Column col = new Column( bh, new ActionCell( "LLST", act ), "LLST" );
	tdesc.addExtraColumn( "_FIRST", col );

	List<TopCell> topCells = new Vector<TopCell>();

	topCells.add( new ListSelectorTopCell( tdesc, isAdmin ) );
	topCells.add( new SeparatorTopCell( tprop, 4 ) );
	topCells.add( new FiltersTopCell( tdesc, null, false, new String[ 0 ], false ) );
	topCells.add( new SortsTopCell( tdesc, null, false, false ) );
	if ( listType == ListType.WORKLIST ) {
		topCells.add( new SeparatorTopCell( tprop, 4 ) );
		topCells.add( new ShowCountsTopCell( tdesc ) );
	}
	topCells.add( new PageTopCell( tprop, tparams ) );
	tdesc.setTopCells( topCells.toArray( new TopCell[ topCells.size() ] ) );


	// --- Oper ---

	if ( !"".equals( parOper ) ) {
		userList.setUser( listUser );
		userList.setList( parListName );
	}

	if ( isSaving ) {
		//List name checking
		if ( "Save".equals( parOper ) || ListSaveForm.SAVEWOFILTERS.equals(parOper)) {
			boolean isAccess = UserList.ACCESSFILTERNAME.equals( parListName ) || UserList.GROUPACCESSFILTERNAME.equals( parListName );

			if ( ListType.WORKLIST == listType && ( isAccess && !parSaveType.equals( parListName ) ) ) {
				throw new IMGeneralException( is,
						LocalizedMessage.getSimpleMessage( "EXCEPTION_LISTS_RESTRICTIVE_NAME" ),
						"cases/index.jsp", LocalizedMessage.getSimpleMessage( "CASES_LISTS_LISTSAVING" ), null );
			}
			String errorMessage = checkListName( listType, listUser, parListName, isAdmin || isUserManager, reqPar, isSupport );
			if ( !"".equals( errorMessage ) ) {
				throw new IMGeneralException( is, errorMessage, GenericUserList.getPrimaryPage( listType ).substring( 1 ),
						LocalizedMessage.getSimpleMessage( "CASES_LISTS_LISTSAVING" ), null );
			}

			// slow query confirmation / message
			// access lists need not be qualified
			if ( ListType.WORKLIST == listType && !parSlowQuery && !isAccess ) {
				QueryQualifier qq = new QueryQualifier();
				String qualif = qq.qualifyFilters( new WorklistTableParams( new IMRequest( is, true ), listUser, true ), true, true );
				if ( !QueryQualifier.GOOD.equals( qualif ) ) {
					WorklistToolbox.generateBadQueryException( is, qq.getHelp(), QueryQualifier.BAD.equals( qualif ),
							returningURL + "&cOper=Save&cListUser=" + Helper.URLEncodeUTF8( listUser.getId() ) + "&cListName=" + Helper.URLEncodeUTF8( parListName ), false );
				}
			}

			ListFile listFile = userList.getListFile();
			if ( ListType.WORKLIST == listType && parListName.equals( ".archive" ) && "@system".equals( listUser.getId() ) ) {
				
				boolean isOldPresent = listFile.exists();
				String modifyOrSet = !isOldPresent ? LocalizedMessage.getSimpleMessage( "OPER_MODIFY" ).toLowerCase() : LocalizedMessage.getSimpleMessage( "OPER_SET" ).toLowerCase();
				throw new IMConfirmationException( is,
						"<CENTER><font color=red><b>" + LocalizedMessage.getCompoundMessage( "EXCEPTION_LISTS_ARCHIVE", new Format[]{ null }, new Object[]{ modifyOrSet }, true ) + "<BR></CENTER>", GenericUserList.getPrimaryPage( listType ).substring( 1 ), LocalizedMessage.getSimpleMessage( "CASES_LISTS_LISTSAVING" ),
						null, returningURL + "&cOper=SaveArchiveFilter&cListUser=" + Helper.URLEncodeUTF8( listUser.getId() ) + "&cListName=" + Helper.URLEncodeUTF8( parListName ) );
			}
			if ( listFile.exists() ) {
				Helper.DEBUG( "lists.jsp", "Enabled Actions (1)" );
				List<String> actionNames = userList.getEnabledActionsNameList();
				//Actions can be used now with worklist-type lists only! 
				if ( ListType.WORKLIST != listType ||
						actionNames == null ||
						actionNames.size() == 0 ) {
					throw new IMConfirmationException(
							"<CENTER>" + LocalizedMessage.getCompoundMessage( "CASES_LISTS_OVEWRITE_MESSAGE", new Format[]{ null }, new Object[]{ htmlListName }, true ) + "<BR></CENTER>",
							GenericUserList.getPrimaryPage( listType ).substring( 1 ), LocalizedMessage.getSimpleMessage( "CASES_LISTS_LISTSAVING" ),
							null, returningURL + "&cOper="+parOper+"OverWrite&cListUser=" + Helper.URLEncodeUTF8( listUser.getId() ) + "&cListName=" + Helper.URLEncodeUTF8( parListName ) + "&cListType=" + listType.getIndex() );
				}
				else { //there are Actions
					response.sendRedirect( "/cases/listop.jsp?cOper=" + Helper.URLEncodeUTF8( "Update Actions" ) + "&cListUser=" + Helper.URLEncodeUTF8( listUser.getId() ) + "&cListName=" + Helper.encodeByRty( parListName ) + "&cListType=" + listType.getIndex() + "&cBackContext=" + context );
					return;
				}
			}
		}
		String errorMessage = checkListName( listType, listUser, parListName, isAdmin || isUserManager, reqPar, isSupport );
		if ( !"".equals( errorMessage ) ) {
			throw new IMGeneralException( is, errorMessage, GenericUserList.getPrimaryPage( listType ).substring( 1 ), "List Saving", null );
		}
		userList.acquireListLock();
		try {
			if ( "SaveOverWriteActions".equals( parOper ) ) {
				if ( ! userList.updateActions( reqPar, is ) ) {
					Format[] msgFormat = new Format[] { null, null };
					Object[] msgObject = new Object[] { Helper.htmlEncode( listUser.getId() ) , htmlListName };

					String message = LocalizedMessage.getCompoundMessage( "EXCEPTION_LIST_UPDATE_ACTIONS", msgFormat, msgObject, true );
					throw new IMGeneralException( is, message, "cases/lists.jsp",
							LocalizedMessage.getSimpleMessage( "GENERAL_ERROR_TITLE" ), null );
				}
				userList.delete( is );
			}
			else if ( parOper.endsWith( "OverWrite" ) ) { // SaveOverWrite || SaveWOFiltersOverWrite
				userList.delete( is );
			}
			else if ( "SaveArchiveFilter".equals( parOper ) ) {
				UserList.backupArchiveList( is );
			}
			reqPar.stickToContext( null );

			UserFile.proliferate( userList.save( listType, reqPar, is, parOper.startsWith( ListSaveForm.SAVEWOFILTERS ) ), ProliferateMode.NORMAL );
		}
		finally {
			userList.releaseListLock();
		}
		response.sendRedirect( is.httpx_host + GenericUserList.getPrimaryPage( listType ) + "?cList_" + listType.getIndex() + "=" +
				Helper.URLEncodeUTF8( listUser.getId() + "/" + parListName ) );
		return;
	}//EndOf Save
	else if ( ListType.WORKLIST == listType && "Configure".equals( parOper ) ) {
		if ( !parSlowQuery && reqPar.getParTable().get( "cEnabled" ) != null ) {
			QueryQualifier qq = new QueryQualifier();
			String qualif = qq.qualifyFilters( new WorklistTableParams( listUser, parListName, false, true ), true, true );
			if ( !QueryQualifier.GOOD.equals( qualif ) ) {
				WorklistToolbox.generateBadQueryException( is, qq.getHelp(), true,
						is.request.getRequestURL() + "?cOper=Configure&" + Helper.passParamsExcept( is.imRequest, "" ), true );
			}
		}

		String actionName = reqPar.getVal( "cAction" );
		DcAction action = DcActionManager.getActionForName( actionName );
		action.setList( listUser, parListName );
		try {
			action.processInput( is, reqPar.getParTable(), is.regID );
		}
		catch( Exception ex ) {
			StringBuilder message = new StringBuilder( 256 );

			Format[] msgFormat = new Format[] { null, null, null };
			Object[] msgObject = new Object[] { actionName, Helper.htmlEncode( listUser.getId() ) , htmlListName };

			message.append( LocalizedMessage.getCompoundMessage( "EXCEPTION_LIST_ENABLE_ACTION_GENERIC", msgFormat, msgObject, true ) );
			if ( ex instanceof IMListFileReadException ) {
				message.append( "<BR/><BR/>" ).append( LocalizedMessage.getSimpleMessage( "EXCEPTION_LIST_ENABLE_ACTION_FILE" ) );
			}

			throw new IMGeneralException( is, message.toString(), "cases/lists.jsp",
					LocalizedMessage.getSimpleMessage( "GENERAL_ERROR_TITLE" ), null );
		}
%>
	<script language="JavaScript">
		document.location="/cases/lists.jsp?cContext=<%=reqPar.getVal("cBackContext")%>";
	</script>
<%
		return;
	}
	else if( "SummaryConfigure".equals( parOper ) ) {
		Summary summary = SummaryManager.getSummaryForName( reqPar.getVal( "cSummary" ) );
		summary.processInput( reqPar.getParTable(), listUser, listType, parListName );
%>
	<script language="JavaScript">
		document.location="/cases/lists.jsp?cContext=<%=reqPar.getVal("cBackContext")%>";
	</script>
<%
		return;
	}
	else if ( "Delete".equals( parOper ) ) {
		UserFile.proliferate( userList.delete( is, true ), ProliferateMode.DELETE );
%>
	<script language="JavaScript">
		document.location="/cases/lists.jsp?cContext=<%=reqPar.getVal("cBackContext")%>";
	</script>
<%
		return;
	}
	else if ( "Override".equals( parOper ) ) {
		UserFile listsDir = ListFile.getFiltersDir( is.getProfileUser(), listType );
		if ( !listsDir.exists() ) {
			listsDir.mkdirs();
		}
		boolean ok = false;
		try {
			ListFile listFile = new ListFile( listUser, listType, parListName );
			if ( listFile.exists() ) {
				ok = Helper.copyAdvanced( listFile.getUserFile().toString(), listsDir.toString(), true, "f" );
			}
		}
		catch( IOException ioe ) {
		}
		if( !ok ) {
			throw new IMGeneralException( is, LocalizedMessage.getCompoundMessage( "EXCEPTION_LISTS_COULD_NOT_COPY_LIST", new Format[] { null }, new Object[] { listsDir.toString() }, true ), GenericUserList.getPrimaryPage( listType ).substring( 1 ), "File copy error", "/cases/lists.jsp" );
		}
	}
	else if ( "BatchDel".equals( parOper ) ) {

		List<String> compoundLists = new ArrayList<String>();
		List<String> compoundListUsers = new ArrayList<String>();
		if ( request.getParameterValues( "cGr" ) != null ) {
			String[] compoundArray = request.getParameterValues( "cGr" );

			for ( int i = 0; i < compoundArray.length; i++ ) {
				String compoundTmp = compoundArray[ i ];

				if ( compoundTmp != null && !compoundTmp.equals( "" ) ) {
					int p = compoundTmp.indexOf( ";" );
					while ( p > 0 ) {
						String next = compoundTmp.substring( 0, p );
						compoundTmp = compoundTmp.substring( p + 1 );
						p = next.indexOf( '/' );
						String compListUser = next.substring( 0, p );
						String compListName = next.substring( p + 1 );
						compoundListUsers.add( compListUser );
						compoundLists.add( compListName );
						p = compoundTmp.indexOf( ";" );
					}
					p = compoundTmp.indexOf( '/' );
					String tmpListUser = compoundTmp.substring( 0, p );
					String tmpListName = compoundTmp.substring( p + 1 );
					compoundListUsers.add( tmpListUser );
					compoundLists.add( tmpListName );
				}
			}
		}
		for ( int i = 0; i < compoundLists.size(); i++ ) {
			userList.setUser( new User( compoundListUsers.get( i ) ) );
			userList.setList( compoundLists.get( i ) );
			UserFile.proliferate( userList.delete( is ), ProliferateMode.DELETE );
		}
%>
	<script language="JavaScript">
		document.location="/cases/lists.jsp?cContext=<%=reqPar.getVal("cBackContext")%>";
	</script>
<%
		return;
	}
	else if ( parOper.startsWith( "Rename" ) ) {
		if ( ListType.WORKLIST == listType && "@system".equals( listUser.getId() ) && ".archive".equals( parNewName ) ) {
			// we permit creating archive filters by simple renaming
			throw new IMGeneralException( is, "You can not create az archive filter by renaming!", thisPageMenuTab, LocalizedMessage.getSimpleMessage( "CASES_LISTS_RENAMELIST" ), returningURL );
		}
		String htmlNewName = Helper.htmlEncode( parNewName, true );
		String errorMessage = checkListName( listType, listUser, parNewName, isAdmin || isUserManager, reqPar, isSupport );
		if ( !"".equals( errorMessage ) ) {
			throw new IMGeneralException( is, errorMessage, thisPageMenuTab, LocalizedMessage.getSimpleMessage( "CASES_LISTS_RENAMELIST" ), returningURL );
		}
		if ( "Rename".equals( parOper ) && filterDirectory.resolve( parNewName + ".rec" ).exists() ) {
			throw new IMConfirmationException( is,
					"<CENTER>" + LocalizedMessage.getCompoundMessage( "CASES_LISTS_OVEWRITE_MESSAGE", new Format[]{ null }, new Object[]{ parNewName }, true ) + "<BR></CENTER>",
					thisPageMenuTab, LocalizedMessage.getSimpleMessage( "CASES_LISTS_RENAMELIST" ), returningURL,
					returningURL + "&cOper=RenameOver&cListUser=" + Helper.URLEncodeUTF8( listUser.getId() ) + "&cListName=" + Helper.URLEncodeUTF8( parListName ) + "&cNewName=" + Helper.URLEncodeUTF8( parNewName ) );
		}
		//userList.rename( parNewName, is );
		ProliferateUserListRename pulr = new ProliferateUserListRename( userList, parNewName ); 
		if ( pulr.run( new imagemed.http.RMISubstitute.RMIContext() ) != 0) {
			throw pulr.m_error;
		}
%>
	<script language="JavaScript">
		document.location="/cases/lists.jsp?cContext=<%=reqPar.getVal("cBackContext")%>";
	</script>
<%
		return;
	}//EndOf Rename , EndOf Oper----------------

	// --- Init Table with Result ---
	
//	if (0 == parListType){
	UserListResult ulr = new UserListResult( tdesc, is.regID, listType, "true".equals( is.imRequest.getVal( ShowCountsTopCell.SHOW_SIZES_PAR ) ) );
	tdesc.setResult( ulr );
/*	}
	else{
		UserFilterListResult ulr = new UserFilterListResult(tdesc);
		tdesc.setResult(ulr);
	}*/
	tdesc.formParams = " action=\"listop.jsp\" method=\"POST\">\n" +
			"<input type=hidden name=\"cBackContext\" value=\"" + context + "\">\n" +
			"<input type=hidden name=\"cOper\" value=\"unset\"";
	Table table = new Table( tdesc );
	
/* for testing only
String[] flds = tparams.getFields();
for (int i=0; i<flds.length; i++){
	is.out.println("<BR>xxx: " + flds[i]);
}
*/


%><%-- --- HTML --- --%>
<HTML>
<HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "CASES_LISTS" ) %></TITLE>
<SCRIPT Language="JavaScript">
	var pageContext="<%=context%>";
</script>
<%
	TabToolbox.writeIMpopup( is.out );
	table.printScript( tparams, is );
//    String selfName = String.valueOf(System.currentTimeMillis());
%>
<SCRIPT language="JavaScript">
	function Oper_( user, list, oper ) {
		top.location = 'listop.jsp?cOper=' + oper + '&cListUser=' + user + '&cListName=' + list +
				'&cBackContext=' + pageContext + '&cListType=<%= listType.getIndex() %>';
	}

	function Batch_( op ) {
		self.document.Batch.cOper.value = op;
		self.document.Batch.submit();
	}

</script>
</head>

<BODY>
<% 
	TabToolbox.makeTabs( is,is.tabbean, thisPageMenuTab, "White" );
%>
<CENTER>
<%

	table.printTableTop( is );

	table.print( is );
%>
</CENTER>
</BODY>
</HTML>
