<%@
  page errorPage ="../main/exceptionHandler.jsp"
%><%@
  page import="imagemed.http.tabs.*, imagemed.imsession.*,imagemed.layout.datasource.*,imagemed.layout.*,imagemed.layout.cache.LayoutCache,
  imagemed.jsputil.*, imagemed.util.LocalizedMessage, imagemed.util.JSHelper, imagemed.util.OperLogEntry, imagemed.util.Syslog,
  imagemed.layout.TimeLine.TlCellDesc,java.util.Map,imagemed.util.Helper"
%><%
	IMSession is = new IMSession(request, response, out);
  if (!is.regOK()) {
    return;
  }
  String baseStudy = is.imRequest.getVal("cStudy");
  if (baseStudy == null || baseStudy.length() == 0) {
  	throw new imagemed.exception.IMException("A base study must be specified.");
  }
	LayoutRoot root = LayoutCache.getSystemLayout(is, LayoutPart.PATIENTFOLDERLAYOUT);
	boolean isRefreshing = "true".equals(request.getParameter( "cRefresh" ) );
 	PatientFolderDataSource dataSource = new PatientFolderDataSource( baseStudy, is, !isRefreshing ); 
 	// initially the datasource is localOnly (will be global is the base study is not local)
 	if (isRefreshing) {
 		try {
 			TimeLine tl = (TimeLine) root.getDescendant( request.getParameter( "tlID" ) );
 			Map<String, TlCellDesc> cellMap = tl.getCells( dataSource );
 			out.print( JSHelper.toJSON( cellMap ) );
 			String vsId = is.COOKIE.getProperty( "ViewSessionID" );
			if (vsId != null && vsId.length( ) > 0){
				ViewSessionProps vsp = ViewSessionProps.readVSP( vsId );
				vsp.setStudyMain(baseStudy);
				vsp.fillStudyStatesMap( is, baseStudy, true );
				vsp.saveVSP();
				// update viewSession data for this PF
			}
 		}
 		catch (Throwable th) {
 			out.print( JSHelper.toJSON( "Updating failed: " + Helper.toString( th ) ) );
 		}
 		return;
 	}
	root.setStretching( true );
 	dataSource.setToBase(); // position to the base study
  OperatingMode mode = LayoutPart.VIEWING;
  boolean isIntegrated = "true".equals(request.getParameter("cIntegrated")); 

	OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "patientfolder" );
	logEntry.setField( OperLogEntry.FIELD.USER, is.regID );
	logEntry.setField( OperLogEntry.FIELD.STUDY, baseStudy );
	logEntry.setField( OperLogEntry.FIELD.PNAME, dataSource.getValue( "PANM" ) );
	logEntry.setField( OperLogEntry.FIELD.MODALITY, dataSource.getValue( "MODY" ) );
	logEntry.setField( OperLogEntry.FIELD.STUDYDATE, dataSource.getValue( "DATE" ) );
	logEntry.log( "cases_patientFolder", 0, Syslog.LOG_INFO );
%>
<html>
<head>
<meta http-equiv="X-UA-Compatible" content="IE=EmulateIE9" />
<title>Patient folder of <%=imagemed.types.IMType.getTypeFor( "PN" ).displayText( dataSource.getValue( "PANM" ) )%></title>
<%TabBean.writeStyleOnly(is);
out.println( StyleToolbox.getStylePart( is, "IMTimeLine" ) );
out.println( StyleToolbox.getStylePart( is, "PatientFolder" ) );
JSHelper.printJsInclude( out, JSHelper.PATIENTFOLDERSCRIPTS_JS );
JSHelper.printJsInclude( out, JSHelper.LAYOUTSCRIPTS_JS );
JSHelper.printJsInclude( out, JSHelper.IMPOPUP_JS );
JSHelper.printJsInclude( out, JSHelper.TABLESCRIPTS_JS );
JSHelper.printJsInclude( out, JSHelper.TIMELINESCRIPTS_JS );
JSHelper.printJsInclude( out, JSHelper.IMTIMELINESCRIPTS_JS ); 
JSHelper.printJsInclude( out, JSHelper.IMIFRAME_JS );
JSHelper.printJsInclude( out, JSHelper.JQUERY_JS );
%>
<script language=javascript>
	ButtonTitles[ "ViewerOpenButton" ] = "<%=LocalizedMessage.getSimpleMessage( "PATIENTFOLDER_ADD_STUDY" )%>";
	ButtonTitles[ "OpenButton" ] = "<%=LocalizedMessage.getSimpleMessage( "BUTTON_OPEN_TITLE" )%>";
	ButtonTitles[ "RetrieveButton" ] = "<%=LocalizedMessage.getSimpleMessage( "PATIENTFOLDER_RETRIEVE_STUDY" )%>";
	ButtonTitles[ "QVButton" ] = "<%=LocalizedMessage.getSimpleMessage( "PATIENTFOLDER_QV_STUDY" )%>";
	ButtonTitles[ "BackButton" ] = "<%=LocalizedMessage.getSimpleMessage( "PATIENTFOLDER_BACK" )%>";
	
<%
	String vsId = request.getParameter("ViewSessionID");
	if (vsId != null && vsId.length( ) > 0 ) {
		Cookie coo = new Cookie( "ViewSessionID", vsId );
		coo.setPath( "/" );
		response.addCookie( coo );
%>
var ViewSessionID = "<%=vsId%>";
<%}%>
window.onbeforeunload = function(e) {
	if ( !checkUnsavedNotes( timeLine ) ) {
		return;
	}
  e = e || window.event;

	var res = "<%=LocalizedMessage.getSimpleMessage( "PATIENTFOLDER_UNSAVED_NOTE" )%>";
  
  // For IE and Firefox prior to version 4
  if (e) {
    e.returnValue = res;
  }

  // For Safari
	return res 
};

</script>
</head>
<body class="stretchedToMargin<%=isIntegrated?" dark tight":""%>">
<table cellspacing=0 cellpadding=0 width=100% height=100%>
<%if (!isIntegrated) { %>
<tr><td>
<%
TabToolbox.makeTabs(is, is.tabbean, "cases/index.jsp", "White");
%>
</td></tr>
<%
} 
else if (vsId != null && vsId.length( ) > 0){
	ViewSessionProps vsp = ViewSessionProps.readVSP( vsId );
	vsp.fillStudyStatesMap( is, baseStudy, true );
	vsp.saveVSP();
	// update viewSession data for this PF
}%>
<tr height=100%><td>
<%=root.getHtml("  ", mode, dataSource)%>
</td></tr></table></body></html>