<%@page import="
	imagemed.jsputil.RedirectToolbox,
	imagemed.dotcom.DotcomConfig,
	imagemed.jsputil.AttachmentManager,
	imagemed.util.RunCommandResult,
	java.util.ArrayList,
	java.util.List,
	imagemed.types.string.IMTypeiS,
	java.sql.ResultSet,
	imagemed.util.Helper,
	imagemed.imsession.IMSession,
	imagemed.imsession.*,
	imagemed.imtables.IMBaseFieldManager,
	java.sql.Statement"

%><%

	IMSession is = new IMSession( request, response, out );
	if ( !is.regOK() ) {
		return;
	}
	String studyIUID = is.request.getParameter( "cStudyIUID" );
	boolean isPDF = "true".equals( is.request.getParameter( "cPDF" ) );
	boolean isUploadOnly = "true".equals( is.request.getParameter( "cUploadOnly" ) );
	String doctypeDefault = is.request.getParameter( "cDoctypeDefault" );
	// boolean isPACSOrder = "true".equals( is.request.getParameter("cPACSOrder") );
	if ( DotcomConfig.selfDevice().isDbOnly() ) {
		//redirect
		String idBase = RedirectToolbox.getRedirectForStudy( is, studyIUID );
		StringBuilder sb = new StringBuilder( idBase );
		sb.append( "/cases/preDicomScan.jsp" + "?cStudyIUID=" + Helper.URLEncodeUTF8( studyIUID ) );
		sb.append( "&cPDF=" + isPDF );
		if ( isUploadOnly ) {
			sb.append( "&cUploadOnly=true" );
		}
		sb.append( "&cDoctypeDefault=" + Helper.URLEncodeUTF8( doctypeDefault ) );
		sb.append( "&" + RedirectToolbox.getRedirectParams( is ) );
		response.sendRedirect( sb.toString() );
		return;
	}
	is.setNonCacheable();
	String uploadURL = "/cases/uploadDicom.jsp";
	if( isUploadOnly ) {
		uploadURL = "/UploadDicom/"; //servlet
	}

	//get series UID
	String seriesUID = "";
	List<String> cmd = new ArrayList<String>();

	cmd.add( IMEnvBase.getEnv( "UTILS_HOME" ) + "/bin/createUID" );
	cmd.add( "series" );
	RunCommandResult runResult = Helper.runCommandEx( cmd.toArray( new String[ 0 ] ) );
	if ( runResult.getExitCode() != 0 ) {
		Helper.ERRORLOG( "DicomUpload", "Generate series UID error: " + runResult.getError() );
	}
	if ( runResult.getOutput() != null ) {
		seriesUID = runResult.getOutput().trim();
	}
	else {
		Helper.ERRORLOG( "DicomUpload", "Generated series UID is NULL!" );
	}

	Helper.DEBUG( "DicomUpload", "Generated series UID: " + seriesUID );

	String refererHost = is.request.getParameter( "RefererHost" );
	String parentSession = is.request.getParameter( "ParentSession" );
	String redirPart = "" + ( refererHost == null ? "" : "&RefererHost=" + refererHost ) + ( parentSession == null ? "" : "&ParentSession=" + parentSession );

	response.sendRedirect( "/scheduler/scan.jsp?cSaveform=false&" + ( isPDF ? "cPDF=true&" : "" ) +
			( isUploadOnly ? "cUploadOnly=true&" : "" ) +
			"cSeriesUID=" + Helper.URLEncodeUTF8( seriesUID ) +
			"&settings=" + AttachmentManager.getScanSettings() + "&cStudyIUID=" + studyIUID +
			"&cDoctypeDefault=" + Helper.URLEncodeUTF8( doctypeDefault ) +
			redirPart +
			"&cUpload=" + Helper.URLEncodeUTF8( uploadURL + "?" + redirPart ) );

%>
