<%--
 ** Component: cases
 **
 ** WEB interface for sending report parts via HL7 (debug function).
 **
 ** Parameters:
 **
 **  @param cStudy        Study Instance UID of study
 **  @param cSRUid        UID of report interpretation (or something like that...)
 **  @param cDevice				The Device where the message is to be sent
 **
 ** $Author$
 ** $Date$
 **
 *
 *  RCS File Name    : $RCSfile$
 *  RCS Revision     : $Revision$
 *  Locked by        : $Locker$
 *  Symbolic name    : $Name$
 *  State            : $State$
--%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="imagemed.util.*,imagemed.imsession.*,imagemed.exception.*"

%>
<%!
	String getParam(IMSession is, String name) throws IMException {
		String value = is.request.getParameter(name);
		if (value == null || value.length() == 0) {
			throw new IMException("Missing parameter: "+name);
		}
		return value;
	}
%>
<%
	IMSession is = new IMSession(request, response, out);

	if (!is.regOK()) {
		return;
	}

	if (!"@support".equals(is.regID)) {
%>
This functionality is restricted to inner (test) use only!
<%
		return;
	}

	String study = getParam(is, "cStudy");
	String sruid = getParam(is, "cSRUid");
	String device = getParam(is, "cDevice");

	String[] cmd = new String[7];
	cmd[0] = IMEnvBase.getEnv("HL7_HOME")+"/bin/sendReport.sh";
	cmd[1] = "-s";
	cmd[2] = study;
	cmd[3] = "-u";
	cmd[4] = sruid;
	cmd[5] = "-d";
	cmd[6] = device;

	String env[] = new String[1];
	env[0] = "HOME=" + IMEnvBase.getEnv("HOME");

	Helper.runCommandEx(cmd, env);
%>
now executing: <%=IMEnvBase.getEnv("HL7_HOME")%>/bin/sendReport.sh -s <%=study%> -u <%=sruid%> -d <%=device%>
<%
	out.flush();
	Thread.sleep(3000);
%>

<Script language="JavaScript">
	self.history.back();
</script>