<%--
 * Parameter:
 *
 * r_no_refresh=true (should not update lastseen)
 * cOp=status|getCells
 *
 * - status query mode (cOp=status)-
 * cStudy: PF's main studyiuid
 * skipNotes: when true the notes will not be collected and returned in the study properties (false by default)
 * 
 * result: JSON object containing a map of local cells in the following format
 *	styiuid -> [status properties object]
 *
 * - cell fetch mode (cOp=getCells) -
 * tlID: ID of the timeline element
 * cStudy: may have multiple values, for each specified study the JSON object used at constructor of TimeLineCell will be returned
 * result: JSON object containing a map of local cells in the following format
 *	styiuid -> [TimeLineCell constructor object]
--%><%@page import="imagemed.layout.cache.LayoutCache,imagemed.util.JSHelper,imagemed.layout.*,imagemed.jsputil.JsonObject,imagemed.jsputil.ViewSessionProps.StudyState,
					java.util.*,imagemed.layout.datasource.PatientFolderDataSource,imagemed.imsession.IMSession"%><%
	IMSession is = new IMSession( request, response, out );
	String strViewSessionID = request.getParameter( "ViewSessionID" );

	if ( !is.regOK() ) {
		return;
	}
	response.setContentType( "application/json" );
	response.setHeader( "Pragma", "no-cache" );

	TimeLine tl = null;

	String op = is.imRequest.getVal( "cOp" );
	boolean isStatus = "status".equals( op );
	if ( "getCells".equals( op ) ) {
		LayoutRoot root = LayoutCache.getSystemLayout(is, LayoutPart.PATIENTFOLDERLAYOUT);
		tl = (TimeLine) root.getDescendant( request.getParameter( "tlID" ) );
		if (tl == null) {
			throw new RuntimeException( "TimeLine instance not found in Layout..." );
		}
	}
	else if ( !isStatus ) {
		throw new RuntimeException( "cOp unknown or missing..." );
	}

	String baseStudy = is.imRequest.getVal( "cStudy" );
	if ( baseStudy == null || baseStudy.length() == 0 ) {
		throw new RuntimeException( "mainStudy not specified..." );
	}
	boolean skipNotes = "true".equals( is.imRequest.getVal( "skipNotes", "false" ) );
	PatientFolderDataSource pfds = new PatientFolderDataSource( baseStudy, is, true );
	Map<String, JsonObject> res = new HashMap<String, JsonObject>();
	int n = pfds.getRepeatCount( null );
	for ( int i = 0; i < n; i++ ) {
		pfds.setRepeatPointer( null, i );
		String study = pfds.getValue( "SYUI" );
		res.put( study, isStatus ? new StudyState( study, is, !skipNotes ) : ( tl.new TlCellDesc( pfds ) ) );
	}
%><%=JSHelper.toJSON( res )%>