<%--
 * Component: cases
 *
 * Description:
 *  Popup window which unlocks study when the user leaving a HTML page which creates study lock.
 *
 * Parameters:
 *
 *   study             Study Instance UID	(single study mode)
 *   cIMLockID         Lock ID
 *								OR							
 *	 cContext					 context containing cLockedStudies	(multiple studies mode)
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@page import="imagemed.types.flag.IMTypeur"%>
<%@
	page import="imagemed.util.*,imagemed.imsession.*,java.sql.*,java.util.*,imagemed.jsputil.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%
	IMSession is = new IMSession( request, response, out ); 
	is.bRegNotNeeded = true; // in case of timeout we lost parameters 
	if ( !is.regOK( !"true".equals( request.getParameter( "cProxy" ) ) ) ) {
		return;
	}
	is.setNonCacheable();
	if ( "true".equals( request.getParameter( "cProxy" ) ) ) {
		Properties rspHeaders = new Properties();
		String host = null; // "autodetect" parent
		String pageUrl = "/cases/unlockwindow.jsp";
		String postData = Helper.replace( Helper.replace( request.getQueryString(), "&cProxy=true", "" ), "cProxy=true&", "" );
		String body = Proxy.issueProxyURL( is, host, pageUrl, postData, rspHeaders );
		out.println( body );
		Helper.writeTextFile( "/tmp/redirect1.txt", body + "\n\n" + Helper.props2String( rspHeaders ) );
		for ( Enumeration<?> headers = rspHeaders.keys(); headers.hasMoreElements(); ) {
			String header = ( String ) headers.nextElement();
			response.setHeader( header, rspHeaders.getProperty( header ) );
		}
		return;
	}
%><HTML><HEAD><TITLE>Release Study</TITLE>
<%
	imagemed.http.tabs.TabBean.writeStyleOnly( is );
%>
</head>
<body>
<center><BR>Unlocking study ...<BR><BR></center>

<%
	String parStudy = request.getParameter( "study" );

	String[] ps = is.imRequest.getVals( "cLocks" );
	String[] parStudies = new String[ 0 ];
	if ( ps != null && ps.length > 0 ) {
		parStudies = new String[ ps.length ];
		for ( int i = 0; i < parStudies.length; i++ ) {
	List<String> current = Helper.decomposeEncodedList( ps[ i ] );
	String id = current.get( 0 );
	if ( id.startsWith( "r_" ) ) {
		id = id.substring( 2 );
	}
	parStudies[ i ] = id;
		}
	}

	// cInstant is only checked if cLocks was provided.
	// cLocks originally was used by batch approve and 
	// without cInstant, releasing study locks is delayed to work-around network issues
	// However in most cases locks need to be released instantly.
	boolean isInstant = "true".equals( request.getParameter( "cInstant" ) );
	
	String backPar = request.getParameter( "cBack" );
	String backURL = request.getParameter( "cBackURL" );

	if ( null == is.regID ) {
		String cookie = is.COOKIE.getProperty( "sessionid" );
		if ( cookie != null ) {
			Statement st = IMEnv.getDB().createStatement();
			ResultSet rs = st.executeQuery( "SELECT USERID FROM " + IMEnvBase.getEnv( "SESSIONTBL" ) + " WHERE SID='" + cookie + "'" );
			if ( rs.next() ) {
				is.setRegID( rs.getString( "USERID" ) );
				rs.close();
				String rights = IMAdminToolbox.getRightsForUser( is.regID );
				is.regRights = rights != null ? rights : "" ;
			}
		}
	}

	if ( parStudy != null && parStudy.length() > 0 ) {
		IMLock.lockStudy( is, parStudy, "Unlock", new Properties() );
	}

	if ( parStudies != null && parStudies.length > 0 ) {
		if ( isInstant ) {
	for ( int i = 0; i < parStudies.length; i++ ) {
		IMLock.lockStudy( is, parStudies[ i ], "Unlock", new Properties() );
	}
		}
		else {
	BatchApproveToolbox.startUnlocking( is );
		}
/*		for ( int i=0; i<parStudies.length; i++ ) {
	Helper.DEBUG( "unlockWindow", "unlocking " + parStudies[ i ] );
	  	Helper.DEBUG( "unlockWindow", "returned "+IMLock.lockStudy( is, parStudies[ i ], "Unlock", new Properties() ) );
		}*/
	}
%>
<script language="JavaScript">
<%
	if ( backURL != null && backURL.length() > 0 ) {
%>
	document.location.href="<%=backURL%>";
<%
	}
	else if ( backPar == null ) {
%>
	window.close();
<%
	}
	else {//may be replaced with real back parameters if needed...
%>
	history.back();
<%
	}
%>
</script>
</body>
</html>
