<%--
* Component: cases
*
* Description:
*  Interface for uploading a file
*
* Parameters (multipart):
*
*   cFile         The content of the new DICOM object
*
* Last Updated     : $Author$
* Update Date Time : $Date$
* RCS File Name    : $RCSfile$
* RCS Revision     : $Revision$
* Locked by        : $Locker$
* Symbolic name    : $Name$
* State            : $State$
*
--%><%@
	page import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,java.io.*,imagemed.types.flag.IMTypeur"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%
	IMSession is = new IMSession(request, response, out);

	MultipartRequest mp = new MultipartRequest(is, IMEnvBase.getEnv("TMP"));

	String parFile     = mp.getParameter("cFile");
	//tmp file name will be in it
	
	Helper.DEBUG( "uploadFile jsp called, parFile:" + parFile );
	
	if (!mp.isMultiPart()) {
		Helper.DEBUG( "Not Multipart request" );
		%>FAILED<%
		return;
	}
	else {
		String rename = mp.getParameter("cRename");
		
		if( rename != null ) {
			Helper.renameTo( new File( parFile ), new File( IMEnvBase.getEnv("TMP") + "/" + rename ) );
		}
		
		is.out.print( "FILE:" + parFile );
		return;
	}
%>