<%--
 * Component: cases
 *
 * Description:
 *    Listing and manipulating user folders
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@page import="imagemed.tables.Table"%>
<%@page import="imagemed.http.tabs.TabBean"%>
<%@page import="imagemed.types.flag.IMTypeur"%><%@
  page errorPage ="../main/exceptionHandler.jsp"

%><%@

  page import="imagemed.imsession.*,imagemed.util.*, imagemed.jsputil.*,imagemed.license.*,
 		imagemed.exception.*,java.io.*,imagemed.types.flag.IMTypeur,imagemed.http.Range"
%><%
	IMSession is = new IMSession(request, response, out); 
	is.bRegNotNeeded = true;
	if (!is.regOK()) {
	  return;
	}
	MultipartRequest req = is.getMpRequest();

	String opValue = req.getParameter( "op" );
	if ( "uploadLic".equals( opValue ) ) {
		
		String pluginName = req.getParameter( "cPluginName" );
		if( pluginName == null ) {
			throw new IMGeneralException( "Missing parameter: No plugin selected!", "imadmin/srvinfo.jsp", "Upload failed", "/cases/uploadpluginlicense.jsp" );		 
		}
		
		// MODE: license is uploaded, save it
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.ADMIN, "uploadpluginlicense" );

		logEntry.setField( OperLogEntry.FIELD.USER, is.regID );
		logEntry.setField( OperLogEntry.FIELD.HOST, is.regIP );
		
		String fileName = req.getParameter( "New" );
		if ( fileName == null ) {
			throw new IMGeneralException( "Missing parameter: No valid file selected! (1)", "imadmin/srvinfo.jsp", "Upload failed", "/cases/uploadpluginlicense.jsp" );		 
		}
		File license = new File( fileName );
		Helper.DEBUG( "licensefilename:" + fileName );
		if ( !license.exists() || license.length() == 0 ) {
			throw new IMGeneralException( "Missing parameter: No valid file selected! (2)", "imadmin/srvinfo.jsp", "Upload failed", "/cases/uploadpluginlicense.jsp" );
		}

		String savename = PluginToolbox.PLUGINSDIR + "/" + pluginName + ".plx";
		
		if( Helper.renameTo( license, new File( savename ) ) ) {
			logEntry.setField( OperLogEntry.FIELD.MESSAGE, pluginName + " license uploaded" );
			logEntry.log( "uploadpluginlicense.jsp", 0, Syslog.LOG_INFO );
		}
		else {
			throw new IMGeneralException( "Couldn't rename the license file to:" + savename, "imadmin/srvinfo.jsp", "Upload failed", "/cases/uploadpluginlicense.jsp" );
		}

%>
		<center><font size="4">
		<%=LocalizedMessage.getSimpleMessage( "IMADMIN_SRVINFO_LICENSE_UPLOADED" ) %>	
		</center>
<script language="JavaScript">
		setTimeout( "document.location='/imadmin/srvinfo.jsp';", 3000 );
</script>
</BODY>
</HTML>
<%		
		return;
	}

%>
<HTML><HEAD><TITLE>Create Plugin License</TITLE><%
  Table.printCommonScript( is );
%>
	<script language="JavaScript">
		function doUpload() {
			var frm = self.document.uploadForm;
			while (frm.cFileName.value != frm.New.value) {
				frm.cFileName.value = frm.New.value;
			}
			frm.submit();
		}
	</script>
</HEAD>
<BODY>
 <CENTER><H3><%=LocalizedMessage.getSimpleMessage( "IMADMIN_SRVINFO_SELECT_PLUGINANDLICENSE" )%></H3>
<%
	StringBuffer result = new StringBuffer();
	result.append( "<FORM name=\"uploadForm\" ENCTYPE=MULTIPART/FORM-DATA METHOD=POST>\n" );
	result.append( "<table border=0 cellpadding=0 cellspacing=8>\n" );
	result.append( "<tr>\n" );
	result.append( "<td valign=center nowrap>\n" );
	result.append( "Plugin ID:\n" );
	result.append( "</td>" );
	result.append( "<td>" );
	
	String[] plugins = PluginToolbox.getAllPluginDlls();
	if( plugins != null ) {
		result.append( "<SELECT NAME=\"cPluginName\">\n" );
		for( String plugin : plugins ) {
			String pluginID = plugin.substring( 0, plugin.length() - 4 ); // cut .dll
			result.append( "<OPTION VALUE=\"" + pluginID + "\">" + pluginID );
		}
		result.append( "</SELECT>" );
	}
	result.append( "</td></tr>" );
	
	result.append( "<tr>\n" );
	result.append( "<td valign=center nowrap>\n" );
	result.append( "<INPUT TYPE=\"FILE\" NAME=\"New\">\n" );
	result.append( "<input type=hidden name=\"cFileName\" value=\"uploaded.xyz\">\n" );
	result.append( "<input type=hidden name=\"op\" value=\"uploadLic\">&nbsp;\n" );
	result.append( "</td>\n" );
	result.append( "<td valign=center nowrap>\n" );
	result.append( "<a href=\"javascript:doUpload()\">" +
			JSHelper.getJsLocalizedButton( "BUTTON_UPLOAD", "BUTTON_NULL", false ) + "</a>\n" );
	result.append( "</td>\n" );
	result.append( "</tr>\n" );
	result.append( "</table>\n" );
	result.append( "</form>\n" );

	out.println( result.toString(  ) ); 
%>

</BODY>
</HTML>


