<%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="imagemed.http.tabs.*, imagemed.imsession.*, imagemed.layout.datasource.*, imagemed.layout.*,
		imagemed.layout.cache.LayoutCache, imagemed.jsputil.*,java.util.*, imagemed.util.*, imagemed.imtables.*,
		imagemed.tables.TableParams"

%><html>
<%
	IMSession is = new IMSession( request, response, out );
	if ( !is.regOK() ) {
		return;
	}
	String study = is.imRequest.getVal( "cStudy" );
	if ( study == null || study.length() == 0 ) {
		throw new imagemed.exception.IMException( "A study must be specified." );
	}
	String studySource = "LOCAL";
	int p = study.indexOf( '_' );
	if ( p > -1 ) {
		studySource = study.substring( 0, p );
		study = study.substring( p + 1 );
		is.imRequest.setProperty( "cStudy", study );
	}
	ReportToolbox.initSession( is );
	LayoutRoot root = null;
	LayoutDataSource dataSource = null;
	root = LayoutCache.getSystemLayout( is, LayoutPart.STUDYLAYOUT );
	if ( "LOCAL".equals( studySource ) ) {
		dataSource = EntryLayoutFactory.getDefaultDBLDS( is, LayoutPart.STUDYLAYOUT );
		( (DBLayoutDataSource) dataSource ).setRowID( Arrays.asList( new String[]{ study } ) );
	}
	else if ( "ARCHIVE".equals( studySource ) ) {
		ArchivesFieldManager afm = new ArchivesFieldManager( ArchivesFieldManager.MODE.AUTORETRIEVES, ArchivesFieldManager.ISSUER.LOCAL );
		TableParams tp = new TableParams();
		tp.setDefaultPageSize( 100 );
		Properties filters = new Properties();
		filters.setProperty( "SYUI", study );
		tp.setDefaultFilters( filters );
		tp.setFields( afm.getFields( EntryLayoutFactory.archiveTable ).toArray( new String[]{} ) );
		ArchivesResult ar = new ArchivesResult( afm, tp, null, true, StudyToolbox.getOwnerHUB( is, null ), false, false );
		dataSource = new ResultDataSource( is, ar );
		//throw new RuntimeException(""+dataSource.getRepeatCount( null ));
	}
	else {
		throw new RuntimeException( "Unrecognized study source (" + studySource + ") for study " + study );
	}
	root.setStretching( true );
	OperatingMode mode = LayoutPart.VIEWING;
%>
<head>
<%
	TabBean.writeStyleOnly( is ); 
	out.println( StyleToolbox.getStylePart( is, "PatientFolder" ) );
	JSHelper.printJsInclude( out, JSHelper.LAYOUTSCRIPTS_JS );
	JSHelper.printJsInclude( out, JSHelper.IMPOPUP_JS );
	JSHelper.printJsInclude( out, JSHelper.TABLESCRIPTS_JS );
	JSHelper.printJsInclude( out, JSHelper.TIMELINESCRIPTS_JS );
	JSHelper.printJsInclude( out, JSHelper.IMTIMELINESCRIPTS_JS );
	JSHelper.printJsInclude( out, JSHelper.IMIFRAME_JS );
	JSHelper.printJsInclude( out, JSHelper.PATIENTFOLDERSCRIPTS_JS );
%>
<SCRIPT Language="JavaScript">

	function checkNotes(added) {
		var oldSize = getSeiSize( noteSeiID );
		if (added && oldSize == 0 || !added && oldSize == 1) {
			// added the first, or deleted the last nore. Update the study cell.
			parent.setNoteState('<%=studySource+"_"+study%>', added);
		}
		document.location.reload();
	};

</script>
<STYLE TYPE="text/css">

	BODY {
		display: block;
		position:absolute;
		height:auto;
		bottom:0;
		top:0;
		left:0;
		right:0;
		margin:0px;
	}

	img.thumbimage {
		height: 64px;
		width: auto;
/*		max-width: 128px;
		max-height: 128px;*/
		vertical-align: middle;
		border: 1px;
		border-color: black;
	}

	img.thumbimage2 {
		height: auto;
		width: 49px;
/*		max-width: 128px;
		max-height: 128px;*/
		vertical-align: middle;
		border: 1px;
		border-color: black;
	}

</STYLE>

<%= StyleToolbox.getStylePart( is, "IMTimeLine" ) %>

</head>
<body>
<%= root.getHtml( "  ", mode, dataSource ) %>
</body>
</html>