<%--
 * Component: cases
 *
 * Description:
 *    Download user profile for the viewer.
 *
--%><%@
	page import="java.io.*,java.sql.*, java.util.*,
			javax.xml.transform.stream.StreamResult, javax.xml.transform.dom.DOMSource, javax.xml.transform.*,
			org.w3c.dom.*, javax.xml.parsers.*,
			imagemed.util.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.users.User"

%><%@
	page errorPage ="../../main/exceptionHandler.jsp"

%><%
	IMSession is = new IMSession( request, response, out ); 

	if ( !is.regOK() ) {
		response.sendError( 403, "ERROR: invalid session" );
		return;
	}

	String resStr = ViewerProfileManager.getAllDataForViewer( is, null, true );

	if( resStr == null ) {
		response.sendError( 403, "ERROR: internal error" );
		return;
	}

	response.setContentType( "text/xml" );
//	response.setHeader( "Content-length", Long.toString( resStr.length() ) );
	response.setHeader( "Pragma", "no-cache" );

	out.println( resStr );

	
	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}
%>
