<%--
 * Component: cases
 *
 * Description:
 *   Download Viewer main page contains links for Viewer Setup and/or Setup Help
 *
--%><%@
	page import="java.io.File, imagemed.util.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.http.IMRequest, imagemed.http.tabs.TabBean"
%><%@
	page errorPage ="../main/exceptionHandler.jsp"
%><%!
	static final int DEFAULT_BITNESS = 32;
%><%
	IMSession is = new IMSession( request, response, out );
	if ( !is.regOK() ) {
		return;
	}
	
%><%-- --- Input Parameters --- --%><%

	IMRequest reqPar = is.imRequest;
	String parBitness = reqPar.getVal( "cBitness" );
	int bitness = -1;
	
	if ( parBitness != null ) {
		try {
			bitness = Integer.parseInt( parBitness );
		}
		catch( NumberFormatException nfe ) {
		}
	}
	
	if ( ( bitness != 32 ) && ( bitness != 64 ) ) {
		//determine bitness
		String userAgent = is.userAgent;
		bitness = TabBean.getOsBitness( userAgent );
		if ( ( bitness != 32 ) && ( bitness != 64 ) ) {
			bitness = DEFAULT_BITNESS;
		}
	}

	String fileName = "/viewer/eradsetup" + DicomSrvToolbox.getProductTypePrefix();
	String fileNameLang = fileName + LocalizedMessage.getActualLocaleAsNamePostfix();
	String fileNameTail = DicomSrvToolbox.getProductNameTail( bitness );
	if ( new File( IMEnvBase.getEnv( "DOCUMENT_ROOT" ) + fileNameLang + fileNameTail ).exists() ) {
		fileName = fileNameLang + fileNameTail;
	}
	else {
		//back to English version
		fileName += fileNameTail;
	}
	
	is.response.sendRedirect( is.httpx_host + fileName );
	if ( true ) {
		return;
	}
%>
